//must corespond with OBJECTIVES[]
/*
const string ISLANDS_CLASSIC[33] = {"Vulcan", "Arachnid", "Fornax","Treasure", "Outpost",
		"Nemesis", "Beacon", "Evergreen", "Frontier", "DeadLock",
		"Endymion", "Granite", "Vattland", "Lingard", "Isolus", "Taksaven",
		"Fulcrum",
		"Sanctuary", "Somnus", "Medusa", "Terminus",	"Duessa", "Acheron",    
		"Naiades", "Avernus", "Bacchus", "Styx", "Hades", "Milestone", "Genetix",
		"Magma", "Obsidian", "Thermopylae"};
*/

#include "scripts/Campaign/IslandsGenerator.h"
/** \addtogroup GameAPI */
/**@{*/
class Classic_Campaign extends CCCampaign
{
	//randomize(-1);

	// player shortcuts
	/** \name Players in campaign */
	//@{
	CCPlayer PlayerNeutral;
	CCPlayer PlayerUEC;
	CCPlayer PlayerAPA;

	//@}

	int VisitedIsland[33];
	int ItemsGroupFactory[10];
	int ItemsGroupRafinery[10];
	int ItemsGroupDefense[10];

	vector EnemyCarrierPos;

	int IslandsUEC;
	int IslandsAPA;

	IslandModel AssignedIslands[27];

	GameProduction ProductionUEC;
	GameProduction ProductionAPA;

	GameStorage CarrierStockUEC;
	GameStorage CarrierStockAPA;
	GameStorage StockUEC;
	GameStorage StockAPA;

	string StockpileUEC;
	string StockpileAPA;
	IslandModel LastAssignedIslandUEC;
	IslandModel LastAssignedIslandAPA;

	int NeutralID;
	int UECID;
	int APAID;

	IslandModel CurrentIsland;
	int CurrentIslandType;
	string CurrentIslandName;
 	string ActiveSlots[33];

//	int RandomMission;
	int CurrID;

	bool CampaignStart;
	bool BanGameMessage;

	//! Classic Starting Dialog
	bool CampaignEnd1;
	bool CampaignEnd2;
	float CapturedRatioUEC;
	float CapturedRatioAPA;
	float ResourcesRatio;
	float IncomeRatio;
	float EnemyStrength;
	float StartingTechLevel;

	bool SelectCarrierAfterLoad;

	float ForceDefence;
	float ForceResource;
	float ForceFactory;

	float UnitSkill;
	float UnitSkillRange;

	int TechLvl;
	int RandomItem;

	int BlueprintsIslandsCnt;
	int BlueprintsCnt;

	int Blueprints[50];
	string BlueprintsIslands[50];

	int RC_FinishedCnt;

	string RC_ACTIVATED[33];
 	string ActiveRCs[33];
	int BlueprintsGroup[33];

	int EvaluatingCarrierAttack;
	float PlayerAPALives;

	// chap 1
	Objective q_ClassicCampaign;
	Objective q_RedDragon;
	string LastSkyPreset;
	float WhichWeatherToSetClassic;
	float WhichTimeToSetClassic;
	string WhichWorldToLoadClassic;
	bool EndOfTheGameClassic;


	/** \name Capture island objectives */
	//@{
	Objective q_VulcanConq;
	Objective q_ArachnidConq;
	Objective q_TreasureConq;
	Objective q_FrontierConq;
	Objective q_OutpostConq;
	Objective q_NemesisConq;
	Objective q_EvergreenConq;
	Objective q_BeaconConq;
	Objective q_FulcrumConq;
	Objective q_BacchusConq;
	Objective q_EndymionConq;
	Objective q_GraniteConq;
	Objective q_TaksavenConq;
	Objective q_VattlandConq;
	Objective q_LingardConq;
	Objective q_IsolusConq;
	Objective q_DuessaConq;
	Objective q_AcheronConq;
	Objective q_TerminusConq;
	Objective q_MedusaConq;
	Objective q_SanctuaryConq;
	Objective q_SomnusConq;
	Objective q_NaiadesConq;
	Objective q_AvernusConq;
	Objective q_FornaxConq;
	Objective q_StyxConq;
	Objective q_HadesConq;
	Objective q_MagmaConq;
	Objective q_MilestoneConq;
	Objective q_IsolusConq;
	Objective q_ObsidianConq;
	Objective q_GenetixConq;
	Objective q_ThermopylaeConq;
	Objective q_DeadlockConq;
	//@}

	//-----------------------------------------------------------
	/** \name Mission objectives */
	//@{
	Objective q_VulcanConqRandom;
	Objective q_ArachnidConqRandom;
	Objective q_TreasureConqRandom;
	Objective q_FrontierConqRandom;
	Objective q_OutpostConqRandom;
	Objective q_NemesisConqRandom;
	Objective q_EvergreenConqRandom;
	Objective q_BeaconConqRandom;
	Objective q_FulcrumConqRandom;
	Objective q_BacchusConqRandom;
	Objective q_EndymionConqRandom;
	Objective q_GraniteConqRandom;
	Objective q_TaksavenConqRandom;
	Objective q_VattlandConqRandom;
	Objective q_LingardConqRandom;
	Objective q_IsolusConqRandom;
	Objective q_DuessaConqRandom;
	Objective q_AcheronConqRandom;
	Objective q_TerminusConqRandom;
	Objective q_MedusaConqRandom;
	Objective q_SanctuaryConqRandom;
	Objective q_SomnusConqRandom;
	Objective q_NaiadesConqRandom;
	Objective q_AvernusConqRandom;
	Objective q_FornaxConqRandom;
	Objective q_StyxConqRandom;
	Objective q_HadesConqRandom;
	Objective q_MagmaConqRandom;
	Objective q_MilestoneConqRandom;
	Objective q_IsolusConqRandom;
	Objective q_ObsidianConqRandom;
	Objective q_GenetixConqRandom;
	Objective q_ThermopylaeConqRandom;
	Objective q_DeadlockConqRandom;
	//@}

	//-----------------------------------------------------------
	/** \name Build CC objectives */
	//@{
	Objective q_VulcanConqCC;
	Objective q_ArachnidConqCC;
	Objective q_NemesisConqCC;
	Objective q_GenetixConqCC;
	Objective q_OutpostConqCC;
	Objective q_MilestoneConqCC;
	Objective q_BacchusConqCC;
	Objective q_EvergreenConqCC;
	Objective q_FrontierConqCC;
	Objective q_TaksavenConqCC;
	Objective q_DuessaConqCC;
	Objective q_MedusaConqCC;
	Objective q_FulcrumConqCC;
	Objective q_BeaconConqCC;
	Objective q_TerminusConqCC;
	Objective q_EndymionConqCC;
	Objective q_GraniteConqCC;
	Objective q_IsolusConqCC;
	Objective q_LingardConqCC;
	Objective q_SanctuaryConqCC;
	Objective q_SomnusConqCC;
	Objective q_VattlandConqCC;
	Objective q_AcheronConqCC;
	Objective q_NaiadesConqCC;
	Objective q_HadesConqCC;
	Objective q_StyxConqCC;
	Objective q_TreasureConqCC;
	Objective q_AvernusConqCC;
	Objective q_MagmaConqCC;
	Objective q_ThermopylaeConqCC;
	Objective q_FornaxConqCC;
	Objective q_ObsidianConqCC;
	Objective q_DeadlockConqCC;

	Objective ISLANDS_OBJECTIVES[33];
	Objective ISLANDS_OBJECTIVES_RAND[33];
	Objective ISLANDS_OBJECTIVES_CC[33];

	//@}

	//! called every frame
	void OnUpdate( float timeSlice )
	{
		UpdateActionQueue(timeSlice);
		if ( dicarrflaretimer1 &&  dicarrflaretimer1 <= 60 && PlayerAPA.GetCarrier() )
			{
			diPlayerAPA.GetCarrierBasic().Stop();
			}
		if ( dicarrflaretimer2 &&  dicarrflaretimer2 <= 60 && PlayerAPA.GetCarrier() )
			{
			diPlayerAPA.GetCarrierBasic().Stop();
			for ( ditempval = 1; ditempval < 5; ditempval++ )
				{
				diunit1 = diPlayerAPA.GetAssembly(ditempval).GetEntity();
				if ( diunit1 != NULL )
					{
					ditemppos = dieunitholdpos[ditempval];
					if ( ditemppos == "0 0 0" )
						{
						dieunitholdpos[ditempval] = diunit1.GetPosition();
						dieunitholdori[ditempval] = diunit1.GetOrientation();
						}
					diunit1.SetPosition(dieunitholdpos[ditempval]);
					diunit1.SetOrientation(dieunitholdori[ditempval]);
					}
				}
			}
		if ( dicarrflaretimer3 &&  dicarrflaretimer3 <= 60 && PlayerAPA.GetCarrier() )
			{
			diPlayerAPA.GetCarrierBasic().Stop();
			for ( ditempval = 6; ditempval < 9; ditempval++ )
				{
				diunit1 = diPlayerAPA.GetAssembly(ditempval).GetEntity();
				if ( diunit1 != NULL )
					{
					ditemppos = dieunitholdpos[ditempval];
					if ( ditemppos == "0 0 0" )
						{
						dieunitholdpos[ditempval] = diunit1.GetPosition();
						dieunitholdori[ditempval] = diunit1.GetOrientation();
						}
					diunit1.SetPosition(dieunitholdpos[ditempval]);
					diunit1.SetOrientation(dieunitholdori[ditempval]);
					}
				}
			}
		diecstatus = q_RedDragon.GetStatus();
		if ( diecstatus != OBJECTIVE_COMPLETE )
			{
			PlayerAPALives = 0;
			if ( dicurrentisland == diecpos )
				{
				if ( dicarrapa && dicarruec )
					{
					if ( dicarrapa.GetHealth() <= 0.05 )
						{
						if ( didrone )
							{
							ditempval = diCarrierStockUEC.AddMaxItemsPossible( EGAMESTORAGE_COMMON, wViewDrone, 1 );
							didrone.GetAssembly().Destroy();
							didrone = NULL;
							}
						for ( ditempval = 1; ditempval < 9; ditempval++ )
							{
							diunit1 = diPlayerAPA.GetAssembly(ditempval).GetEntity();
							if ( diunit1 )
								diunit1.GetAssembly().Destroy();
							diunit1 = diunit[ditempval];
							if ( diunit1 && !diunit1.IsDocked() )
								{
								ditempvale = diunit1.GetAssembly().IsFullyDeployed();
								ditemppos = diunit1.GetPosition();
								ditempori = diunit1.GetOrientation();
								diunit1.GetAssembly().InstantDeploy( ditemppos, 0 );
								diunit1.GetAssembly().InstantDock();
								if ( ditempvale )
									{
									diunit1.GetAssembly().InstantDeploy( ditemppos, 0 );
									diunit1.SetOrientation( ditempori );
									}
								}
							}
						diecstatus = OBJECTIVE_COMPLETE;
						dicarruec.SelectForPlayer();
						dicurrent = dicarruec;
						dicarruec = NULL;
						dicarrapa = NULL;
						dicarruecactive = false;
						g_Game.ShowAction();
						q_RedDragon.SetStatus ( OBJECTIVE_COMPLETE );
						diqueueloadoverridetimer = 3;
						difadetimer = 10;
						}
					}
				}
			}
		if ( diecmove || diecmoveforce || diecstatus == OBJECTIVE_COMPLETE && g_Game.InCutscene() )
			{
			ditempval = difriendlyislands + dienemyislands;
			ditempvalb = g_Game.GetNumIslands();
			diecrsisltype1 = 2;
			diecrsisltype2 = 1;
			diecrsisltype3 = 0;
			if ( dienemyislands >= 2 )
				{
				diecrsisltype1 = 2;
				diecrsisltype2 = 2;
				diecrsisltype3 = 2;
				}
			if ( dienemyislands <= 1 && ditempval < ditempvalb - 1 )
				{
				diecrsisltype1 = 2;
				diecrsisltype2 = 2;
				diecrsisltype3 = 0;
				}
			diecrsisl = rand ( 1, ditempvalb );
			diecrsisl -= 1;
			if ( diislstatus[diecrsisl] == diecrsisltype1 || diislstatus[diecrsisl] == diecrsisltype2 || diislstatus[diecrsisl] == diecrsisltype3 )
				{
				if ( diecrsisl != dicurrentisland2 || !diislstatusdisp )
					{
					diPlayerAPA.GetCarrierBasic().Stop();
					diPlayerAPA.SpawnCarrier( g_Game.FindIslandByName( diislname[diecrsisl] ), CarrierArmored, false );
					diPlayerAPA.GetCarrier().Hide();
					if ( diecmoveforce )
						diradarmsgoverride = 3;
					diecmoveforce = false;
					}
				}
			}
		if ( !g_Game.InCutscene() && dicarrapa != NULL && dicarruec != NULL )
			{
			if ( diecrs )
				{
				CarrierStockAPA.AddItem( EGAMESTORAGE_COMMON,fCarrierFuel10 , 4 );
				diPlayerAPA.GetCarrierStorage().AddItem( EGAMESTORAGE_UNIT, bodyManta, 4 );
				diPlayerAPA.GetCarrierStorage().AddItem( EGAMESTORAGE_UNIT, bodyWalrus, 4 );
				q_RedDragon = g_Game.CreateObjective( NULL, "#obj_reddragon_title", "#obj_reddragon_desc", OBJECTIVE_PENDING, true, 0 );
				q_RedDragon.SetStatus ( OBJECTIVE_PENDING );
				diecstop = false;
				diecrstimer = 0;
				dicarrapa.DisableComplex();
				dicarrapa.EnableComplex();
				}
			if ( diecstop && diislstatusdisp )
				{
				dicarrapa.GetLocalRepairZone( ECARRIER_ZONE_ENGINES ).SetHealth( 0.0, true );
				dicarrapa.GetLocalRepairZone( ECARRIER_ZONE_SUPERSTRUCTURE ).SetHealth( 0.05, true );
				dicarrapa.SetFuel( 0 );
				diPlayerAPA.GetCarrierBasic().Stop();
				diPlayerAPA.SpawnCarrier( diPlayerAPA.GetCurrentIsland(), CarrierArmored, false );
				dicarrapa.Hide();
				for ( ditempval = 1; ditempval < 9; ditempval++ )
					{
					diunit1 = diPlayerAPA.GetAssembly(ditempval).GetEntity();
					if ( diunit1 != NULL )
						diunit1.GetAssembly().Destroy();
					}
				}
			}
		if ( dirolereversal == 1 )
			{
			diskipadvisor = true;
			diPlayerAPA.GetCarrierBasic().Stop();
			for ( ditempval = 0; ditempval < g_Game.GetNumIslands(); ditempval++ )
				{
				g_Game.GetIsland(ditempval).AssignToPlayer ( PlayerNeutral, true );
				if ( diislstatus[ditempval] == 1 )
					{
					g_Game.GetIsland(ditempval).AssignToPlayer ( diPlayerAPA, true );
					g_Game.GetIsland(ditempval).UniPostRestore();
					}
				else
					{
					if ( diislstatus[ditempval] == 2 )
						g_Game.GetIsland(ditempval).AssignToPlayer ( diPlayerUEC, true );
					}
				g_Game.GetIsland(ditempval).SetType(diisltype[ditempval]);
				g_Game.GetIsland(ditempval).SetType(diisltype[ditempval]);
				diislstatusdisp = false;
				}
			direset = true;
			diskipadvisor = false;
			diapatargetisl = dicurrentisland2;
			diuectargetisl = diecpos2;
			dirolereversal = 2;
			}
		if ( dirolereversal > 1 )
			{
			dirolereversal++;
			if ( diecpos2 == diapatargetisl && dicurrentisland2 == diuectargetisl || dirolereversal > 200 )
				dirolereversal = 0;
			if ( dicurrentisland2 != diuectargetisl )
				{
				diPlayerUEC.GetCarrierBasic().Stop();
				diPlayerUEC.SpawnCarrier ( g_Game.FindIslandByName( diislname[diuectargetisl] ), CarrierArmored, false );
				}
			if ( diecpos2 != diapatargetisl )
				{
				for ( ditempval = 1; ditempval < 9; ditempval++ )
					{
					diunit1 = diPlayerAPA.GetAssembly(ditempval).GetEntity();
					if ( diunit1 != NULL )
						diunit1.GetAssembly().InstantDock();
					}
				diPlayerAPA.GetCarrierBasic().Stop();
				diPlayerAPA.SpawnCarrier ( g_Game.FindIslandByName( diislname[diapatargetisl] ), CarrierArmored, false );
				}
			}
	}

	/** \name Help Fuctions for Slot Activation handling in CC:Classic */
	//@{
	//-----------------------------------------------------------------------------------------------------------------
	void SlotActivatorInit( Activator activator, string islandName )
	{
		activator.DisableUse();
		activator.EnableCammoRemap();

		for( int i = 0; i < sizeof( ActiveSlots ); i++ )
		{
			if ( islandName != ActiveSlots[i] )
				continue;

			Print( "SlotActivatorInit Slot can be hacked");
			activator.EnableUse();
			activator.DisableCammoRemap();
			break;
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void SlotActivatorUsed( Activator activator, string islandName )
	{
		activator.DisableUse();
		activator.EnableCammoRemap();
		for( int i = 0; i < sizeof( ActiveSlots ); i++ )
		{
			if ( islandName == "" ) continue;
			if ( islandName == ActiveSlots[i] )
			{
				ActiveSlots[i] = "";
				break;
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void SlotRestoration( string islandName )
	{
		bool alreadyActive = false;
		
		for( int k = 0; k < sizeof( ActiveSlots ); k++ )
		{
			//check - asi nejaka chyba, nemel by v seznamu byt uveden
			if ( islandName == ActiveSlots[k] )
				alreadyActive = true;
		}

		if ( !alreadyActive )
		{
			for ( k = 0; k < sizeof( ActiveSlots ); k++ )
			{
				if ( ActiveSlots[k] == "" )
				{
					ActiveSlots[k]= islandName;
					break;
				}
			}
		}
	}
	//@}

	/** \name Help Fuctions for RC Activation handling in CC:Classic */
	//@{
	//-----------------------------------------------------------------------------------------------------------------
	void RCActivatorInit( Activator activator, string islandName )
	{
		activator.DisableUse();
		activator.EnableCammoRemap();

		for( int i = 0; i < sizeof( RC_ACTIVATED ); i++ )
		{
			if ( islandName != RC_ACTIVATED[i] )
				continue;

			Print( "RC  can be hacked");
			activator.EnableUse();
			activator.DisableCammoRemap();
			break;
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	bool RC_IsActive( string islandName )
	{
		for( int i = 0; i< sizeof( RC_ACTIVATED ); i++ )
		{
			if ( RC_ACTIVATED[i] == "")
				continue;
			if ( RC_ACTIVATED[i] == islandName )
				return false;
		}
		return true;
	}

	//-----------------------------------------------------------------------------------------------------------------
	void RC_Finished( string islandName )
	{
		for( int i = 0; i < sizeof( BlueprintsIslands ); i++ )
		{
			string island = BlueprintsIslands[i];
			if ( islandName != island)
				continue;
			else
			{
				int item = BlueprintsGroup[i];
				EnableProductionEx( PlayerUEC, item );
				RC_ACTIVATED[RC_FinishedCnt] = islandName;

				if ( item == -1 )
					g_Game.ShowHint("ShowAdvisor: Tenhle blueprint uz bohuzel mame, takze cesta sem byla zbytecna", 10, false );

				if ( item == upgradeComputer )
					EnableProductionEx( PlayerUEC, upgradeComputerManta );

				if ( item == wMantaMissile )
				{
					EnableProductionEx( PlayerUEC, wMantaTomahawk );					
					EnableProductionEx( PlayerUEC, wWalrusLauncher );
				}

				RC_FinishedCnt += 1;
				break;
			}
		}
	}

	//-----------------------------------------------------------------------------------------------------------------
	void RC_ActivatorUsed( Activator activator, string islandName )
	{
		DialogAction didialogaction;
		if ( diresearch )
			diresearch.ForcePlayer(diPlayerUEC)
		if ( diPlayerUEC.GetProduction().IsEnabled( dircbpa[dicurrentisland2]) && diPlayerUEC.GetProduction().IsEnabled( dircbpb[dicurrentisland2]) )
			{
			didialogaction = CreateDialogAction(CGO_OWNER_CAMPAIGN, NORMAL_PRIORITY, 100.0, -1);
			didialogaction.AddSentenceAction( "#adv_blueprint_notfound_essi_01", 50.0, "AdvisorEssi");
			didialogaction.ToQueue();
			}
		if ( !diPlayerUEC.GetProduction().IsEnabled( dircbpa[dicurrentisland2]) )
			{
			disetarticlename( dircbpa[dicurrentisland2] );
			g_Game.AddMessage( "RESEARCH BONUS - #blueprint_gained ", COLOR_YELLOW, 1, diarticlename );
			diPlayerUEC.GetProduction().Enable(dircbpa[dicurrentisland2])
			}
		if ( !diPlayerUEC.GetProduction().IsEnabled( dircbpb[dicurrentisland2]) )
			{
			disetarticlename( dircbpb[dicurrentisland2] );
			g_Game.AddMessage( "RESEARCH BONUS - #blueprint_gained ", COLOR_YELLOW, 1, diarticlename );
			diPlayerUEC.GetProduction().Enable(dircbpb[dicurrentisland2])
			}
		ditempintb = 0;
		for ( ditempval = 0; ditempval < 33; ditempval++ )
			{
			if ( !diPlayerUEC.GetProduction().IsEnabled( dircbpa[ditempval]) || !diPlayerUEC.GetProduction().IsEnabled( dircbpb[ditempval] ) )
				ditempintb = 1;
			}
		if ( !ditempintb )
			{
			didialogaction = CreateDialogAction(CGO_OWNER_CAMPAIGN, NORMAL_PRIORITY, 100.0, -1);
			didialogaction.AddSentenceAction( "#adv_blueprints_all_done_essi_01", 50.0, "AdvisorEssi");
			didialogaction.ToQueue();
			}
//		//Get Command Center player
//		if ( g_Game.GetCommandCenter() != NULL && g_Game.GetCommandCenter().GetPlayer() == PlayerUEC )
//		{
			activator.DisableUse();
//			RC_Finished( islandName );
//		}
/*
		else
		{
			CTSV_chapII_ResearchCentre_noCode();
		}
*/
	}
	//@}

	//-----------------------------------------------------------------------------------------------------------------
	//!	Checks if the given island has neighbour of given player
	bool HasNeighborsOfPlayer( IslandModel island, CCPlayer player )
	{
		IslandModel neighbors[8];
		int neighCount = 0;
		island.GetConnectedNeighbors( neighbors, neighCount );
		for( int i = 0; i < neighCount; i++ )
		{
			IslandModel isl = neighbors[i];
			if ( isl != NULL && isl.GetPlayer() == player )
				return true;
		}
		return false;
	}

	//-----------------------------------------------------------------------------------------------------------------
	//! Helping function for right inicialization of CC:Classic (load/save issues)
	void CampaignClassicInit( IslandModel pIsland )
	{
		CarrierStockUEC = PlayerUEC.GetCarrierStorage();
		StockUEC = PlayerUEC.GetStockpileStorage();
		CarrierStockAPA = PlayerAPA.GetCarrierStorage();				

/* We agreed to remove this dialog in Patch
#ifndef DEVELOPER
		if ( !g_Achievements.IsAchieved( AchieveEvidenceOfCrash ) )
			g_Game.ShowDialog( "#strat_game_notutorial_title", "#strat_game_notutorial_desc", 2, DBT_OK, DBB_OK, DMT_INFO );
#endif
*/
		// Use current island, you already set island before !
		// Game might want to override your choice before load is even processed

		//-------------------------------------------------------------
		//                           UEC Carrier                       
		//-------------------------------------------------------------
		g_Game.ShowMap();

		PlayerUEC.SpawnCarrier( pIsland, CarrierDefault, false );
		PlayerUEC.SpawnBarque();

		Carrier carrier = PlayerUEC.GetCarrier();
//		int isl = g_Game.GetBestStockpile( PlayerUEC );
//		IslandModel stock = g_Game.GetIsland( isl );
//		if ( stock )
//			PlayerUEC.SetStockpile( stock );

		//Wait(carrier != NULL )

		carrier.SelectForPlayer();
		carrier.OnToDockPoint(NULL);
		RepairSystem system = carrier.GetRepairSystem();
		system.EnableRepairs( true );

		SetDefaultRepairPriorities( carrier );
		BanGameMessage = true;

		if ( ResourcesRatio > 0.7 )
			carrier.AddEquipment( wCarrierFrontShell );
		else
		{
			if ( ResourcesRatio > 0.3 )
				carrier.AddEquipment( wCarrierFrontPlasma );
		}

		carrier.EnableItems();

		float itemCnt = ResourcesRatio * 10;
		int itemCntRare = itemCnt / 5 ;

		//Add Items on UEC Stockpile
		//-------------------------------------------------------------
		StockUEC.AddItem( EGAMESTORAGE_COMMON, fCarrierFuel10, 4 + itemCnt );
		StockUEC.AddItem( EGAMESTORAGE_COMMON, fCarrierFuel, 0 + itemCnt );

		//--------------------------------------------------------------
		//					APA carrier               				
		//--------------------------------------------------------------
		PlayerAPA.SpawnCarrier( g_Game.FindIslandByName( StockpileAPA ), CarrierArmored, false );
		PlayerAPA.SpawnBarque();
		carrier = NULL;
		carrier = PlayerAPA.GetCarrier();

		Wait(carrier != NULL )
		carrier.SetMinimalEngineRatio( 0.1 );

		//carrier.OnToDockPoint(NULL);
		system = carrier.GetRepairSystem();
		system.EnableRepairs( true );
		SetDefaultRepairPrioritiesAPA( carrier );

		carrier.AddEquipment( wCarrierFrontPlasma );
		carrier.AddEquipment( wCarrierRightGatling );
		carrier.AddEquipment( wCarrierLeftGatling );
		carrier.AddEquipment( wCarrierRearRightGatling );
		carrier.AddEquipment( wCarrierRearLeftGatling );
		carrier.EnableItems();

		//Add Items on both Carriers
		//-------------------------------------------------------------
		//General Items                                                
		//-------------------------------------------------------------
		//Add items into carrier if is its tech level is smaller or equal the tech level from init screen
		//Fuels
		CarrierStockUEC.AddItem( EGAMESTORAGE_COMMON,fCarrierFuel10 , 4 );
		CarrierStockAPA.AddItem( EGAMESTORAGE_COMMON,fCarrierFuel10 , 4 );

		//Add Other Items 
		for( int n = 0; n < sizeof( ITEMS ) ; n++ )
		{
			if ( ITEMS[n] == wMantaTorpedo || ITEMS[n] == upgradeMantaShield || ITEMS[n] == wWalrusHowitzer || ITEMS[n] == wWalrusLauncher )
				continue;

			GameProductionItem item = PlayerUEC.GetProduction().GetItem( ITEMS[n] );
			int startingAPALevel = StartingTechLevel + 1;
			
			float itemCar = item.GetMaxCarrier();
			float itemMax = itemCar * 1.5;
			float itemMin = 0;

			if ( item.GetSupport() == 0 && StartingTechLevel > item.GetTechLevel() )
				itemMax = itemCar * 0.8;
			
			//To have some more Hulls on stockpile
			if ( ITEMS[n] == bodyWalrus || ITEMS[n] == bodyManta )
				itemMax *= 1.8;

			float itemTime = item.GetProductionTimeOriginal() / 3600;
			if ( itemTime <= 3.4 )
				itemMin = 1;

			itemMax = LerpFloats( itemMin, itemMax, ResourcesRatio );

			int tempS = StartingTechLevel - 1;

			//added to have more items on carrier at start with tech level slider on max (4) - we have not this tech lvl
			if ( StartingTechLevel == 3 )
				tempS -=1;

			if ( tempS > item.GetTechLevel() )
			{
				if ( item.GetSupport() == 0  && ITEMS[n] != bodyManta  && ITEMS[n] != bodyWalrus )
					itemMax = 0;
			}

			float itemRest = itemMax - floor( itemMax );
			if ( itemRest > 0.5 )
				itemMax += 1;

			itemMax = floor( itemMax );
			
			int itemCaPa = itemMax + 2;

			if ( StartingTechLevel >= item.GetTechLevel() )
			{
				int left = CarrierStockUEC.AddMaxItemsPossible( EGAMESTORAGE_COMMON, ITEMS[n], itemMax );
				if ( left > 0 )
					StockUEC.AddItem( EGAMESTORAGE_COMMON, ITEMS[n] , left );
			}
			
			if ( startingAPALevel >= item.GetTechLevel() )
			{
				left = CarrierStockAPA.AddMaxItemsPossible( EGAMESTORAGE_COMMON, ITEMS[n], itemCaPa );
				if ( left > 0 )
					StockAPA.AddItem( EGAMESTORAGE_COMMON, ITEMS[n] , left );
			}
		}

		//Vehicle bodies
		CarrierStockUEC.AddItem( EGAMESTORAGE_UNIT, bodyManta, 4 );
		CarrierStockUEC.AddItem( EGAMESTORAGE_UNIT, bodyWalrus, 4 );

		CarrierStockAPA.AddItem( EGAMESTORAGE_UNIT, bodyManta, 4 );
		CarrierStockAPA.AddItem( EGAMESTORAGE_UNIT, bodyWalrus, 4 );

		BanGameMessage = false;
		CampaignStart = false;

		g_Game.ChooseZoomLevel( 5 );
		g_Game.ShowMap();
	}

	//-----------------------------------------------------------------------------------------------------------------
	//! Set right current task (called from IslandCaptured etc. )
	void SetCurrentTask( bool leaving )
	{
		IslandModel island = g_Game.GetCurrentIsland();
		//int doubleApa = IslandsAPA * 2;
		bool haveEnoughStr = false;
		int pointsOfStr = 0;
		
		//Zjisti jestli ma torpedo na carrieru (ci mante)
		//a jestli muze vyrabet vsechny flak veze na carrier (lepsi kdyz by se dalo zjistit jestli jsou osazene, ale to ted nejde)
		
		GameProduction production = PlayerUEC.GetProduction();
		if ( production.IsEnabled( wMantaTorpedo ) )
		{
			if ( HasPlayerItem( wMantaTorpedo, true) > 0 )
				pointsOfStr++;
		}

		if ( production.IsEnabled( wCarrierFrontShell ) || production.IsEnabled( wCarrierFrontPlasma ) )
			pointsOfStr++;
		if ( production.IsEnabled( wCarrierLeftFlak ) )
			pointsOfStr++;
		if ( production.IsEnabled( wCarrierRightFlak ) )
			pointsOfStr++;
		if ( production.IsEnabled( wCarrierRearLeftFlak ) )
			pointsOfStr++;
		if ( production.IsEnabled( wCarrierRearRightFlak ) )
			pointsOfStr++;

		if ( pointsOfStr >= 6 )
			haveEnoughStr = true;

		if ( !island )
		{
			if ( haveEnoughStr )
			{
				SetCurrentObjective( q_RedDragon );
				SetCurrentObjectiveShiplog( q_RedDragon );
			}
			else
			{
				SetCurrentObjective( q_ClassicCampaign );
				SetCurrentObjectiveShiplog( q_ClassicCampaign );
			}

			if ( !CampaignEnd2 )
			{
				SetCurrentObjective( q_RedDragon );
				SetCurrentObjectiveShiplog( q_RedDragon );
			}

			if ( !CampaignEnd1 )
			{
				SetCurrentObjective( q_ClassicCampaign );
				SetCurrentObjectiveShiplog( q_ClassicCampaign );
			}	

			return;
		}

		Objective newObjective = NULL;
		Objective newShiplog = NULL;
		Objective current = GetCurrentObjective();
		Objective currentShiplog = GetCurrentObjective();
		Objective objIsl = q_ClassicCampaign;

		if ( !CampaignEnd2 )
		{
			SetCurrentObjective( q_RedDragon );
			SetCurrentObjectiveShiplog( q_RedDragon );
			return;
		}

		if ( !CampaignEnd1 )
		{
			SetCurrentObjective( q_ClassicCampaign );
			SetCurrentObjectiveShiplog( q_ClassicCampaign );
			return;
		}

		if ( q_RedDragon.GetStatus() == OBJECTIVE_COMPLETE )
		{
			SetCurrentObjective( q_ClassicCampaign );
			SetCurrentObjectiveShiplog( q_ClassicCampaign );
			return;
		}
		
		if ( q_ClassicCampaign.GetStatus() == OBJECTIVE_COMPLETE || !CampaignEnd1 )
		{
			SetCurrentObjective( q_RedDragon );
			SetCurrentObjectiveShiplog( q_RedDragon );
			return;
		}

		if ( leaving )
		{
			if ( island.GetPlayer() != PlayerUEC )
			{
				if ( haveEnoughStr )
				{
					newObjective = q_RedDragon;
					newShiplog = q_RedDragon;
				}
				else
				{
					newObjective = q_ClassicCampaign;
					newShiplog = q_ClassicCampaign;
				}
			}
		
			if ( current == q_RedDragon || haveEnoughStr )
			{
				newShiplog = q_RedDragon;
				newObjective = q_RedDragon;
			}
			else
			{
				newShiplog = q_ClassicCampaign;	
				newObjective = q_ClassicCampaign;
			}
		}
		else
		{
			if ( island.GetPlayer() == PlayerUEC )
			{
				if ( haveEnoughStr )
				{
					newShiplog = q_RedDragon;
					newObjective = q_RedDragon;
				}
				else
				{
					newShiplog = q_ClassicCampaign;
					newObjective = q_ClassicCampaign;
				}
			}

			if ( island.GetPlayer() == PlayerAPA )
			{
				if ( current != q_RedDragon || current != q_ClassicCampaign )
				{
					Objective objCurrent = GetIslandObjective( q_ClassicCampaign, island);
					if ( objCurrent != NULL )
					{
						Objective objMis = objCurrent.GetSubObjective(0);
						if ( objMis != NULL && objMis.GetStatus() == OBJECTIVE_PENDING )
						{
							newShiplog = objMis;
							newObjective = objMis;
						}
						else
						{
							int islObjectives = objCurrent.GetSubObjectivesCount();
							for( int c = 0; c < islObjectives; c++ )
							{
								Objective missionObj = objCurrent.GetSubObjective( c );
								if ( island.GetUniPostMission() > 0 )
								{
									if ( missionObj.GetStatus() == OBJECTIVE_PENDING )
									{
										newShiplog = objIsl;
										newObjective = objIsl;
										break;
									}
								}
								else
								{
									newShiplog = objCurrent;
									newObjective = objCurrent;
								}
							}
						}
					}
				}
				else
				{
					if ( current == q_RedDragon )
					{
						newShiplog = q_RedDragon;
						newObjective = q_RedDragon;
					}
					else
					{
						newShiplog = q_ClassicCampaign ;
						newObjective = q_ClassicCampaign;
					}
				}
			}

			if ( island.GetPlayer() == PlayerNeutral )	
			{
				islObjectives = objCurrent.GetSubObjectivesCount();
				for( c = 0; c < islObjectives; c++ )
				{
					missionObj = objCurrent.GetSubObjective( c );
					if ( missionObj.GetStatus() == OBJECTIVE_PENDING )
					{
						newShiplog = objIsl;
						newObjective = objIsl;
						break;
					}
				}
			}
		}
		
		if ( newObjective != current && !CampaignStart )
			g_Game.PlayGameSound( "ui/NewObjective" );

		SetCurrentObjective( newObjective );
		SetCurrentObjectiveShiplog( newShiplog );

	}

	//! Called when new entity created upon assembly
	void OnAssemblyResurrect( EntityBasic pBasic )
	{
/*
		if( pBasic.GetPlayer() == PlayerUEC )
		{
			//Equip it like a scout
			if( pBasic.GetSlot() == 1 )
			{
				if ( ResourcesRatio > 0.7 )
				{
					pBasic.SetEquipmentForce( armorMantaMedium );
					pBasic.SetEquipmentForce( wMantaGatlings );				
					pBasic.SetEquipmentForce( wMantaRocket );
					pBasic.SetEquipmentForce( upgradeComputerManta );
				}
				else
				{
					if ( ResourcesRatio > 0.3 )
					{
						pBasic.SetEquipmentForce( armorMantaMedium );
						pBasic.SetEquipmentForce( wMantaLasers );
						pBasic.SetEquipmentForce( wFlaresManta );
					}
					else
					{
						pBasic.SetEquipmentForce( wMantaMachineGuns );	
						pBasic.SetEquipmentForce( wMantaRocket );
					}
				}
			}

			//Equip it like a AT fighter
			if( pBasic.GetSlot() == 2 )
			{
				if ( ResourcesRatio > 0.7 )
				{
					pBasic.SetEquipmentForce( armorMantaMedium );
					pBasic.SetEquipmentForce( wMantaPlasmas );
					pBasic.SetEquipmentForce( wMantaRocket );
					pBasic.SetEquipmentForce( wMantaTomahawk );
				}
				else
				{
					if ( ResourcesRatio > 0.3 )
					{
						pBasic.SetEquipmentForce( armorMantaMedium );
						pBasic.SetEquipmentForce( wMantaLasers );
					}
					else
						pBasic.SetEquipmentForce( wMantaMachineGuns );
				}
			}

			//Equip it like a AL fighter
			if( pBasic.GetSlot() == 3 )
			{
				if ( ResourcesRatio > 0.7 )
				{
					pBasic.SetEquipmentForce( armorMantaHeavy );
					pBasic.SetEquipmentForce( wMantaGatlings );	
					pBasic.SetEquipmentForce( wMantaMissile );
					pBasic.SetEquipmentForce( wMantaBomb );
				}
				else
				{
					if ( ResourcesRatio > 0.3 )
					{
						pBasic.SetEquipmentForce( armorMantaMedium );
						pBasic.SetEquipmentForce( wMantaLasers );
						pBasic.SetEquipmentForce( wFlaresManta );
					}
					else
					{
						pBasic.SetEquipmentForce( wMantaMachineGuns );
					}
				}
			}

			//Equip it like a tank
			if( pBasic.GetSlot() == 4 )
			{
				if ( ResourcesRatio > 0.7 )
				{
					pBasic.SetEquipmentForce( armorMantaHeavy );
					pBasic.SetEquipmentForce( wMantaLasers );
					pBasic.SetEquipmentForce( wMantaMissile );
				}
				else
				{
					if ( ResourcesRatio > 0.3 )
					{
						pBasic.SetEquipmentForce( armorMantaMedium );
						pBasic.SetEquipmentForce( wMantaMachineGuns );
					}
					else
						pBasic.SetEquipmentForce( wMantaMachineGuns );
				}
			}

			//Walruses
			//-------------------------------------------------------------------------------------
			//Equip it like a hacker
			if( pBasic.GetSlot() == 5 )
			{
				if ( ResourcesRatio > 0.7 )
				{
					pBasic.SetEquipmentForce( armorWalrusMedium );
					pBasic.SetEquipmentForce( wWalrusGatling );
					pBasic.SetEquipmentForce( capsuleHack );
				}
				else
				{
					if ( ResourcesRatio > 0.3 )
					{
						pBasic.SetEquipmentForce( armorWalrusMedium );
						pBasic.SetEquipmentForce( wWalrusLaser );
						pBasic.SetEquipmentForce( capsuleHack );
					}
					else
					{
						pBasic.SetEquipmentForce( armorWalrusMedium );
						pBasic.SetEquipmentForce( wWalrusLaser );
						pBasic.SetEquipmentForce( capsuleHack );
					}
				}
			}

			//Equip it like a AA specialist
			if( pBasic.GetSlot() == 6 )
			{
				if ( ResourcesRatio > 0.7 )
				{
					pBasic.SetEquipmentForce( armorWalrusHeavy );
					pBasic.SetEquipmentForce( wWalrusFlak );
				}
				else
				{
					if ( ResourcesRatio > 0.3 )
					{
						pBasic.SetEquipmentForce( armorWalrusMedium );
						pBasic.SetEquipmentForce( wWalrusAA );
					}
					else
						pBasic.SetEquipmentForce( wWalrusLaser );
				}
			}


			//Equip it like a dps
			if( pBasic.GetSlot() == 7 )
			{
				if ( ResourcesRatio > 0.7 )
				{
					pBasic.SetEquipmentForce( armorWalrusHeavy );
					pBasic.SetEquipmentForce( wWalrusPlasma );
				}
				else
				{
					if ( ResourcesRatio > 0.3 )
					{
						pBasic.SetEquipmentForce( armorWalrusMedium );
						pBasic.SetEquipmentForce( wWalrusShell );
					}
					else
						pBasic.SetEquipmentForce( wWalrusGrenade );
				}
			}

			//Equip it like a healer or something else
			if( pBasic.GetSlot() == 8 )
			{
				if ( ResourcesRatio > 0.7 )
				{
					pBasic.SetEquipmentForce( armorWalrusHeavy );
					pBasic.SetEquipmentForce( wWalrusRepairGun );
				}
				else
				{
					if ( ResourcesRatio > 0.3 )
					{
						pBasic.SetEquipmentForce( armorWalrusMedium );
						pBasic.SetEquipmentForce( wWalrusRepairGun );
					}
					else
						pBasic.SetEquipmentForce( wWalrusMachineGun );
				}
			}
		}
*/
	}

	//! Constructor of the campaign
	void Classic_Campaign()
	{
		g_Game.TempEnableAlternativeRandomizer( true );

		CampaignLog( "[CC:Classic] >>> Carrier Command: Classic campaign created." );

		g_Game.SetWorldNameMap("worlds/StrategyWorld.ent");

		PlayerNeutral = NULL;
		PlayerUEC = NULL;
		PlayerAPA = NULL;

		CurrentIsland = NULL;
		CurrentIslandType = 0;
		CurrentIslandName = "";

		IslandsUEC = 0;
		IslandsAPA = 0;

		BanGameMessage = false;
		SelectCarrierAfterLoad = false;

		TechLvl = 0;
		MultiForce = 1.0;

		ForceDefence = 1.5;
		ForceResource = 0.5;
		ForceFactory = 0.7;

		BlueprintsIslandsCnt = 0;
		BlueprintsCnt = 10;

		UnitSkill = 0.5;
		UnitSkillRange = 0.2;

		StockpileUEC = "NULL";
		StockpileAPA = "NULL";
		LastAssignedIslandUEC = NULL;
		LastAssignedIslandAPA = NULL;

		RandomItem = -1;
		EvaluatingCarrierAttack = 1;				//lock for OnCarrierAttack, for just one passage, not multiple

		int index = 0;
		Blueprints[index++] = wMantaTorpedo;
		Blueprints[index++] = upgradeMantaShield;
		Blueprints[index++] = wWalrusHowitzer;
		Blueprints[index++] = wWalrusLauncher;
		Blueprints[index++] = wCarrierFrontShell;
		Blueprints[index++] = wCarrierLeftFlak;
		Blueprints[index++] = wCarrierRightFlak;
		Blueprints[index++] = wCarrierRearLeftFlak;
		Blueprints[index++] = wCarrierRearRightFlak;
		Blueprints[index++] = wCarrierHammerHead;
		
		index = 0;
		ItemsGroupFactory[index++] = armorWalrusMedium;
		ItemsGroupFactory[index++] = armorMantaMedium;
		ItemsGroupFactory[index++] = armorWalrusHeavy;
		ItemsGroupFactory[index++] = armorMantaHeavy;
		ItemsGroupFactory[index++] = armorWalrusMedium;
		ItemsGroupFactory[index++] = armorMantaMedium;
		ItemsGroupFactory[index++] = bodyManta;
		ItemsGroupFactory[index++] = bodyWalrus;
		ItemsGroupFactory[index++] = armorWalrusHeavy;
		ItemsGroupFactory[index++] = armorMantaHeavy;

		index = 0;
		ItemsGroupRafinery[index++] = upgradeAmmoBox;
		ItemsGroupRafinery[index++] = upgradeAmmoBoxManta;
		ItemsGroupRafinery[index++] = capsuleResource;
		ItemsGroupRafinery[index++] = capsuleHack;
		ItemsGroupRafinery[index++] = upgradeMantaShield;
		ItemsGroupRafinery[index++] = capsuleDefense;
		ItemsGroupRafinery[index++] = fCarrierFuel10;
		ItemsGroupRafinery[index++] = upgradeAmmoBox;
		ItemsGroupRafinery[index++] = upgradeAmmoBoxManta;
		ItemsGroupRafinery[index++] = fCarrierFuel10;

		index = 0;
		ItemsGroupDefense[index++] = wWalrusGatling;
		ItemsGroupDefense[index++] = wWalrusLauncher;
		ItemsGroupDefense[index++] = wWalrusHeat;
		ItemsGroupDefense[index++] = wWalrusFlak;
		ItemsGroupDefense[index++] = wWalrusHowitzer;
		ItemsGroupDefense[index++] = wMantaMissile;
		ItemsGroupDefense[index++] = wMantaTomahawk;
		ItemsGroupDefense[index++] = wWalrusShell;
		ItemsGroupDefense[index++] = wMantaRocket;
		ItemsGroupDefense[index++] = wMantaBomb;

		for( int k = 0; k < sizeof( VisitedIsland ); k++ )
		{
			VisitedIsland[k] = 0;
		}
	}

	//! Destructor
	void ~Classic_Campaign()
	{
	}

	//! Set global pointers for production after load
	void GainProduction()
	{
		PlayerUEC = g_Game.GetPlayer(1);
		PlayerAPA = g_Game.GetPlayer(2);
	
		ProductionUEC = PlayerUEC.GetProduction();
		ProductionAPA = PlayerAPA.GetProduction();
		CarrierStockUEC = PlayerUEC.GetCarrierStorage();
		CarrierStockAPA = PlayerAPA.GetCarrierStorage();
		StockUEC = PlayerUEC.GetStockpileStorage();
		StockAPA = PlayerAPA.GetStockpileStorage();		
		ProductionUEC = PlayerUEC.GetProduction();
		ProductionAPA = PlayerAPA.GetProduction();
	}

	//---------------------------
	//! Search for position of given island in given array
	int SearchInIslandArray( IslandModel array[], int cnt, IslandModel island )
	{
		int pos = -1;
		int xLoop = 0;
		
		while( pos == -1 && xLoop < cnt)
		{
			if ( array[xLoop] )
			{
				if (array[xLoop] == island)
					pos = xLoop;
			}
			xLoop++;
		}
		return pos;
	}

	//---------------------------
	//! Count of islands in given array
	int CountIslandArray( IslandModel array[] )
	{
		int num = 0;

		for ( int i = 0; i < sizeof( array ); i++ )
		{
			IslandModel island = array[i];
			if( island != NULL)
				num ++;
		}

		return num;
	}

	//---------------------------
	//! Distribute islands among players on campaign start
	void InitPlayersNetwork( IslandModel startIsland, CCPlayer player, int islandCnt )
	{
		//GetStrategyPos
		int k = 0;
		int cntAsg = 0;
		int allIslandsInGame = g_Game.GetNumIslands();

		IslandModel islands[128];
		IslandModel assignedIslands[128];
		IslandModel island;


		//INIT
		
		for( int i = 0; i < allIslandsInGame; i++ )
		{
			if ( allIslandsInGame > sizeof( assignedIslands ) )
				return;
			islands[i] = NULL;
			assignedIslands[i] = NULL;
		}

		islands[0] = startIsland;
		if ( player == PlayerUEC )
			StockpileUEC = startIsland.GetName();
		else
			StockpileAPA = startIsland.GetName();

		int cnt = 1;

		while( k < islandCnt )
		{
			IslandModel neighbors[8];
			int neighCount = 0;
			
			island = islands[0];

			if ( !island )
			{
				for ( int z = 0; z < allIslandsInGame; z++ )
				{
					IslandModel islandNew = g_Game.GetIsland(z);
					if ( islandNew.GetPlayer().GetID() != 0 )
						continue;

					islands[0] = islandNew;
					island = islandNew;
				}
			}

			if ( !island ) break;

			islands[0] = NULL;
			island.AssignToPlayer( player, true );
			if ( player == PlayerUEC )
				LastAssignedIslandUEC = island;
			else
				LastAssignedIslandAPA = island;			

			assignedIslands[cntAsg] = island;
			cntAsg ++;

			//ten check je hotfix, nutno vyzkouset jestli se to nevy... nekde jinde
			if ( cnt > 0)
				cnt--;
			k++;

			CompactPtrArray( islands, sizeof(islands) );
			island.GetConnectedNeighbors( neighbors, neighCount );

			for( int l = 0; l < neighCount; l++)
			{
				IslandModel isl = neighbors[l];
				if ( !isl || isl.GetPlayer().GetID() != 0 )
					continue;

				if ( SearchInIslandArray( islands, allIslandsInGame, isl ) < 0 )
				{
					islands[cnt] = isl;
					cnt++;
				}
			}
		}
	}

	/** \name Function called from C++ side ( it's better to take them like Events ) */
	//@{

	//! Create players
	bool OnCreatePlayers()
	{
		CampaignLog( "[CC:Classic] >>> ---------------------------------------------------------------", 5 );
		CampaignLog( "[CC:Classic] >>> OnCreatePlayers()", 5 );
		CGame game = GetGame();
		if( !game ) return false; // no game to enter, dude!

		// Neutral player already exist - just read!
		PlayerNeutral = game.GetPlayer( 0 );

		//! DO NOT CHANGE ORDER, OR ELSE EVERYTHING WILL SCREW UP!
		PlayerUEC = game.CreateNewPlayer( "UEC" );
		PlayerUEC.SetColors( 0xff00aeff, /* 0xfff6a80e */ 0xffffffff,/* 0xff4aaafc */ 0xffffffff );

		PlayerAPA = game.CreateNewPlayer( "APA" );
		PlayerAPA.SetColors( 0xffff0000, 0xffe30107, 0xffbc0207);

		g_Game.SetControlledPlayer( PlayerUEC.GetID() /* 1 */ );

		// set global pointers for production
		GainProduction();

		CampaignLog( "[CC:Classic] >>> Distributing islands among players...", 5 );

#ifdef DEVELOPER
		PlayerUEC.EnableIslandUnitControl(true);
#endif
	    return true;
	}

	//! Set Stockpiles when creating strategy game
	bool OnCreateStrategic()
	{
		IslandModel stockUEC = g_Game.FindIslandByName( StockpileUEC );
		if( stockUEC )
		{
			PlayerUEC.SetStockpile(stockUEC);
			stockUEC.SetType( IslandMine );
		}
		
		IslandModel stockAPA = g_Game.FindIslandByName( StockpileAPA );
		if( stockAPA )
		{
			PlayerAPA.SetStockpile(stockAPA);
			stockAPA.SetType( IslandMine );
		}
			
		return true;
	}

	//! Entering Campaign if paramete is NULL command line
	bool OnEnterCampaign( IslandModel pIsland )
	{
		CampaignLog( "[CC:Classic] >>> ---------------------------------------------------------------", 5 );
		//CGame game = GetGame();
		if( !g_Game )
		return false; // no game to enter, dude!

		CampaignLog( "[CC:Classic] >>> OnEnterCampaign()", 5 );
		CampaignStart = true;
		CreateMainActionQueue();

		CampaignEnd1 = g_VictoryCondition1;
		CampaignEnd2 = g_VictoryCondition2;
		CapturedRatioUEC = g_CapturedRatio;
		CapturedRatioAPA = g_CapturedRatio2;
		ResourcesRatio = g_ResourcesRatio;
		IncomeRatio = g_IncomeRatio;
		EnemyStrength = g_EnemyStrength;
		StartingTechLevel = g_TechLevel;

		PlayerAPALives = 10 * g_EnemyStrength;
		
		if ( pIsland != NULL )
		{
			CapturedRatioUEC = 0.5;
			CapturedRatioAPA = 0.5;
			ResourcesRatio = 0.5;
			IncomeRatio = 0.5;
			EnemyStrength = 0.5;
			CampaignEnd1 = true;
			CampaignEnd2 = true;
			StartingTechLevel = 1;
			PlayerAPALives = 5; 
		}

		Print(PlayerAPALives);

		//------------------------------------------------------------------
		//                        Setup OBJECTIVES here                     
		//------------------------------------------------------------------

		int index = 0;

		if ( CampaignEnd1 )
			q_RedDragon = g_Game.CreateObjective( NULL, "#obj_reddragon_title", "#obj_reddragon_desc", OBJECTIVE_PENDING, false, 0 );
		else
			q_RedDragon = g_Game.CreateObjective( NULL, "#obj_reddragon_title", "#obj_reddragon_desc", OBJECTIVE_PENDING, true, 0 );

		if ( CampaignEnd2 )
			q_ClassicCampaign =	g_Game.CreateObjective( NULL, "#obj_classic_title", "#obj_classic_desc", OBJECTIVE_PENDING, false, 0 );
		else
			q_ClassicCampaign =	g_Game.CreateObjective( NULL, "#obj_classic_title", "#obj_classic_desc", OBJECTIVE_PENDING, true, 0 );

		q_VulcanConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_vulcan", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ArachnidConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_arachnid", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_NemesisConq = 	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_nemesis", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_GenetixConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_genetix", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_OutpostConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_outpost", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MilestoneConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_milestone", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_BacchusConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_bacchus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_EvergreenConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_evergreen", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FrontierConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_frontier", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TaksavenConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_taksaven", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_DuessaConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_duessa", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MedusaConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_medusa", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FulcrumConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_fulcrum", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_BeaconConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_beacon", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TerminusConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_terminus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_EndymionConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_endymion", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_GraniteConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_granite", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_IsolusConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_isolus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_LingardConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_lingard", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_SanctuaryConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_sanctuary", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_SomnusConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_somnus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_VattlandConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_vattland", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_AcheronConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_acheron", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_NaiadesConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_naiades", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_HadesConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_hades", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_StyxConq =			g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_styx", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TreasureConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_treasure", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_AvernusConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_avernus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MagmaConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_magma", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ThermopylaeConq=	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_thermopylae", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FornaxConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_fornax", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ObsidianConq =		g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_obsidian", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_DeadlockConq =	g_Game.CreateObjective( q_ClassicCampaign, "#obj_currentisland_title" + "#island_deadlock", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );

		ISLANDS_OBJECTIVES[index++] = q_VulcanConq;
		ISLANDS_OBJECTIVES[index++] = q_ArachnidConq;
		ISLANDS_OBJECTIVES[index++] = q_NemesisConq;
		ISLANDS_OBJECTIVES[index++] = q_GenetixConq;
		ISLANDS_OBJECTIVES[index++] = q_OutpostConq;
		ISLANDS_OBJECTIVES[index++] = q_MilestoneConq;

		ISLANDS_OBJECTIVES[index++] = q_BacchusConq;
		ISLANDS_OBJECTIVES[index++] = q_EvergreenConq;
		ISLANDS_OBJECTIVES[index++] = q_FrontierConq;
		ISLANDS_OBJECTIVES[index++] = q_TaksavenConq;
		ISLANDS_OBJECTIVES[index++] = q_DuessaConq;

		ISLANDS_OBJECTIVES[index++] = q_MedusaConq;
		ISLANDS_OBJECTIVES[index++] = q_FulcrumConq;
		ISLANDS_OBJECTIVES[index++] = q_BeaconConq;
		ISLANDS_OBJECTIVES[index++] = q_TerminusConq;
		ISLANDS_OBJECTIVES[index++] = q_EndymionConq;
		ISLANDS_OBJECTIVES[index++] = q_GraniteConq;

		ISLANDS_OBJECTIVES[index++] = q_IsolusConq;
		ISLANDS_OBJECTIVES[index++] = q_LingardConq;
		ISLANDS_OBJECTIVES[index++] = q_SanctuaryConq;
		ISLANDS_OBJECTIVES[index++] = q_SomnusConq;
		ISLANDS_OBJECTIVES[index++] = q_VattlandConq;

		ISLANDS_OBJECTIVES[index++] = q_AcheronConq;
		ISLANDS_OBJECTIVES[index++] = q_NaiadesConq;
		ISLANDS_OBJECTIVES[index++] = q_HadesConq;
		ISLANDS_OBJECTIVES[index++] = q_StyxConq;
		ISLANDS_OBJECTIVES[index++] = q_TreasureConq;

		ISLANDS_OBJECTIVES[index++] = q_AvernusConq;
		ISLANDS_OBJECTIVES[index++] = q_MagmaConq;
		ISLANDS_OBJECTIVES[index++] = q_ThermopylaeConq;
		ISLANDS_OBJECTIVES[index++] = q_FornaxConq;
		ISLANDS_OBJECTIVES[index++] = q_ObsidianConq;
		ISLANDS_OBJECTIVES[index++] = q_DeadlockConq;

		q_VulcanConqRandom =		g_Game.CreateObjective( q_VulcanConq, "#obj_currentisland_title" + "#island_vulcan", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ArachnidConqRandom =	g_Game.CreateObjective( q_ArachnidConq, "#obj_currentisland_title" + "#island_arachnid", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_NemesisConqRandom = 	g_Game.CreateObjective( q_NemesisConq, "#obj_currentisland_title" + "#island_nemesis", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_GenetixConqRandom =		g_Game.CreateObjective( q_GenetixConq, "#obj_currentisland_title" + "#island_genetix", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_OutpostConqRandom =		g_Game.CreateObjective( q_OutpostConq, "#obj_currentisland_title" + "#island_outpost", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MilestoneConqRandom =	g_Game.CreateObjective( q_MilestoneConq, "#obj_currentisland_title" + "#island_milestone", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_BacchusConqRandom =	g_Game.CreateObjective( q_BacchusConq, "#obj_currentisland_title" + "#island_bacchus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_EvergreenConqRandom =	g_Game.CreateObjective( q_EvergreenConq, "#obj_currentisland_title" + "#island_evergreen", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FrontierConqRandom =		g_Game.CreateObjective( q_FrontierConq, "#obj_currentisland_title" + "#island_frontier", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TaksavenConqRandom =	g_Game.CreateObjective( q_TaksavenConq, "#obj_currentisland_title" + "#island_taksaven", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_DuessaConqRandom =		g_Game.CreateObjective( q_DuessaConq, "#obj_currentisland_title" + "#island_duessa", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MedusaConqRandom =		g_Game.CreateObjective( q_MedusaConq, "#obj_currentisland_title" + "#island_medusa", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FulcrumConqRandom =		g_Game.CreateObjective( q_FulcrumConq, "#obj_currentisland_title" + "#island_fulcrum", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_BeaconConqRandom =		g_Game.CreateObjective( q_BeaconConq, "#obj_currentisland_title" + "#island_beacon", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TerminusConqRandom =	g_Game.CreateObjective( q_TerminusConq, "#obj_currentisland_title" + "#island_terminus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_EndymionConqRandom =	g_Game.CreateObjective( q_EndymionConq, "#obj_currentisland_title" + "#island_endymion", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_GraniteConqRandom =		g_Game.CreateObjective( q_GraniteConq, "#obj_currentisland_title" + "#island_granite", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_IsolusConqRandom =		g_Game.CreateObjective( q_IsolusConq, "#obj_currentisland_title" + "#island_isolus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_LingardConqRandom =		g_Game.CreateObjective( q_LingardConq, "#obj_currentisland_title" + "#island_lingard", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_SanctuaryConqRandom =	g_Game.CreateObjective( q_SanctuaryConq, "#obj_currentisland_title" + "#island_sanctuary", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_SomnusConqRandom =		g_Game.CreateObjective( q_SomnusConq, "#obj_currentisland_title" + "#island_somnus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_VattlandConqRandom =	g_Game.CreateObjective( q_VattlandConq, "#obj_currentisland_title" + "#island_vattland", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_AcheronConqRandom =	g_Game.CreateObjective( q_AcheronConq, "#obj_currentisland_title" + "#island_acheron", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_NaiadesConqRandom =		g_Game.CreateObjective( q_NaiadesConq, "#obj_currentisland_title" + "#island_naiades", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_HadesConqRandom =		g_Game.CreateObjective( q_HadesConq, "#obj_currentisland_title" + "#island_hades", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_StyxConqRandom =		g_Game.CreateObjective( q_StyxConq, "#obj_currentisland_title" + "#island_styx", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TreasureConqRandom =	g_Game.CreateObjective( q_TreasureConq, "#obj_currentisland_title" + "#island_treasure", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_AvernusConqRandom =		g_Game.CreateObjective( q_AvernusConq, "#obj_currentisland_title" + "#island_avernus", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MagmaConqRandom =		g_Game.CreateObjective( q_MagmaConq, "#obj_currentisland_title" + "#island_magma", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ThermopylaeConqRandom=g_Game.CreateObjective( q_ThermopylaeConq, "#obj_currentisland_title" + "#island_thermopylae", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FornaxConqRandom =		g_Game.CreateObjective( q_FornaxConq, "#obj_currentisland_title" + "#island_fornax", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ObsidianConqRandom =	g_Game.CreateObjective( q_ObsidianConq, "#obj_currentisland_title" + "#island_obsidian", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_DeadlockConqRandom =	g_Game.CreateObjective( q_DeadlockConq, "#obj_currentisland_title" + "#island_deadlock", "#obj_currentisland_desc", OBJECTIVE_UNAVAILABLE, false, 0 );

		index = 0;
		ISLANDS_OBJECTIVES_RAND[index++] = q_VulcanConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_ArachnidConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_NemesisConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_GenetixConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_OutpostConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_MilestoneConqRandom;

		ISLANDS_OBJECTIVES_RAND[index++] = q_BacchusConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_EvergreenConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_FrontierConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_TaksavenConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_DuessaConqRandom;

		ISLANDS_OBJECTIVES_RAND[index++] = q_MedusaConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_FulcrumConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_BeaconConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_TerminusConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_EndymionConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_GraniteConqRandom;

		ISLANDS_OBJECTIVES_RAND[index++] = q_IsolusConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_LingardConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_SanctuaryConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_SomnusConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_VattlandConqRandom;

		ISLANDS_OBJECTIVES_RAND[index++] = q_AcheronConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_NaiadesConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_HadesConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_StyxConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_TreasureConqRandom;

		ISLANDS_OBJECTIVES_RAND[index++] = q_AvernusConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_MagmaConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_ThermopylaeConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_FornaxConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_ObsidianConqRandom;
		ISLANDS_OBJECTIVES_RAND[index++] = q_DeadlockConqRandom;

		q_VulcanConqCC =		g_Game.CreateObjective( q_VulcanConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ArachnidConqCC =		g_Game.CreateObjective( q_ArachnidConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_NemesisConqCC = 		g_Game.CreateObjective( q_NemesisConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_GenetixConqCC =		g_Game.CreateObjective( q_GenetixConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_OutpostConqCC =		g_Game.CreateObjective( q_OutpostConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MilestoneConqCC =		g_Game.CreateObjective( q_MilestoneConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_BacchusConqCC =		g_Game.CreateObjective( q_BacchusConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_EvergreenConqCC =	g_Game.CreateObjective( q_EvergreenConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FrontierConqCC =		g_Game.CreateObjective( q_FrontierConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TaksavenConqCC =	g_Game.CreateObjective( q_TaksavenConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_DuessaConqCC =		g_Game.CreateObjective( q_DuessaConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MedusaConqCC =		g_Game.CreateObjective( q_MedusaConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FulcrumConqCC =		g_Game.CreateObjective( q_FulcrumConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_BeaconConqCC =		g_Game.CreateObjective( q_BeaconConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TerminusConqCC =		g_Game.CreateObjective( q_TerminusConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_EndymionConqCC =		g_Game.CreateObjective( q_EndymionConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_GraniteConqCC =		g_Game.CreateObjective( q_GraniteConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_IsolusConqCC =			g_Game.CreateObjective( q_IsolusConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_LingardConqCC =		g_Game.CreateObjective( q_LingardConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_SanctuaryConqCC =	g_Game.CreateObjective( q_SanctuaryConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_SomnusConqCC =		g_Game.CreateObjective( q_SomnusConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_VattlandConqCC =		g_Game.CreateObjective( q_VattlandConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_AcheronConqCC =		g_Game.CreateObjective( q_AcheronConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_NaiadesConqCC =		g_Game.CreateObjective( q_NaiadesConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_HadesConqCC =		g_Game.CreateObjective( q_HadesConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_StyxConqCC =			g_Game.CreateObjective( q_StyxConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_TreasureConqCC =		g_Game.CreateObjective( q_TreasureConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_AvernusConqCC =		g_Game.CreateObjective( q_AvernusConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_MagmaConqCC =		g_Game.CreateObjective( q_MagmaConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ThermopylaeConqCC=	g_Game.CreateObjective( q_ThermopylaeConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_FornaxConqCC =		g_Game.CreateObjective( q_FornaxConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_ObsidianConqCC =		g_Game.CreateObjective( q_ObsidianConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );
		q_DeadlockConqCC =		g_Game.CreateObjective( q_DeadlockConq, "#obj_objective_ccbuild_title", "#obj_currentislandbuild_desc", OBJECTIVE_UNAVAILABLE, false, 0 );

		index = 0;
		ISLANDS_OBJECTIVES_CC[index++] = q_VulcanConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_ArachnidConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_NemesisConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_GenetixConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_OutpostConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_MilestoneConqCC;

		ISLANDS_OBJECTIVES_CC[index++] = q_BacchusConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_EvergreenConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_FrontierConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_TaksavenConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_DuessaConqCC;

		ISLANDS_OBJECTIVES_CC[index++] = q_MedusaConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_FulcrumConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_BeaconConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_TerminusConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_EndymionConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_GraniteConqCC;

		ISLANDS_OBJECTIVES_CC[index++] = q_IsolusConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_LingardConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_SanctuaryConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_SomnusConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_VattlandConqCC;

		ISLANDS_OBJECTIVES_CC[index++] = q_AcheronConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_NaiadesConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_HadesConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_StyxConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_TreasureConqCC;

		ISLANDS_OBJECTIVES_CC[index++] = q_AvernusConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_MagmaConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_ThermopylaeConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_FornaxConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_ObsidianConqCC;
		ISLANDS_OBJECTIVES_CC[index++] = q_DeadlockConqCC;

		BlueprintsGroup[0] = wWalrusLaser;
		BlueprintsGroup[1] = wMantaTomahawk;
		BlueprintsGroup[2] = armorWalrusHeavy;
		BlueprintsGroup[3] = wMantaBomb;
		BlueprintsGroup[4] = wWalrusShell;
		BlueprintsGroup[5] = wMantaTorpedo;
		BlueprintsGroup[6] = wWalrusLaser;
		BlueprintsGroup[7] = armorWalrusHeavy;
		BlueprintsGroup[8] = wMantaBomb;
		BlueprintsGroup[9] = wWalrusShell;


		//------------------------------------------------------------------
		//                      SetUp random mission on islands                           
		//------------------------------------------------------------------
		int allIslands = g_Game.GetNumIslands();
		IslandModel rIsland = g_Game.GetIsland(0);
		if ( rIsland.GetUniPostMission() == MISSION_NOTSET )
		{
			int scramMission = 0;
			int compMission = 0;
			int shieldMission = 0;
			int noMission = 0;
			int rM = frand( MISSION_NOTSET, MISSION_CC_SHIELD );

			for( int i = 0; i < allIslands; i++ )
			{
				float f = frand( 0,1 ); // for random island Type
				Objective obj = NULL;
				Objective objIsl = NULL;
				Objective objCC = NULL;
				IslandModel island = g_Game.GetIsland(i);
				
				if ( !island )
					continue;

				Objective objCurrent = GetIslandObjective( q_ClassicCampaign, island);
				if ( objCurrent != NULL )
				{
					Objective genMission = objCurrent.GetSubObjective( 0 );
					Objective ccMission = objCurrent.GetSubObjective( 1 );
				}

				string text = SetMissionsTexts( genMission, rM, island )
				switch( text )
				{
					case "NO GENERIC MISSION":
						noMission += 1;
						rM = 1;
						break;

					case "SCRAMBLERS" :
						scramMission +=1;
						rM = 2;
						break;

					case "COMPUTER DEFENCE" :
						compMission +=1;
						rM = 3;
						break;

					case "CC SHIELD" :
						shieldMission += 1;
						rM = 0;
						break;

					default:
						island.SetUniPostType( UniPostDisruptor_uni, false );
						break;
				}

				if ( island.GetPlayer() != PlayerUEC )
				{
					objCurrent.SetStatus( OBJECTIVE_PENDING );
					
					if ( island.GetPlayer() == PlayerNeutral )
						ccMission.SetStatus( OBJECTIVE_PENDING );

					if ( island.GetPlayer() == PlayerAPA && island.IsConnectedToEnemy() && genMission.GetTitle() != "NO GENERIC MISSION")
						genMission.SetStatus( OBJECTIVE_PENDING );

				}
			}

			string cc_classic;
			CampaignLog("[CC:Classic] >>> Kolik je misi toho jednoho typu je:", 1);
			cc_classic = "[CC:Classic] >>> Scramblers Missions: " + itoa( scramMission );
			CampaignLog( cc_classic, 1 );
			cc_classic = "[CC:Classic] >>> Firewalls Missions: " + itoa( compMission );
			CampaignLog( cc_classic, 1 );
			cc_classic = "[CC:Classic] >>> Shields Missions: " + itoa( shieldMission );
			CampaignLog( cc_classic, 1 );
			cc_classic = "[CC:Classic] >>> No Missions: " + itoa( noMission );
			CampaignLog( cc_classic, 1 );
		}

		//------------------------------------------------------------------
		//                      Setup islands owners here                                   
		//------------------------------------------------------------------

		int maxIslands = g_Game.GetNumIslands() - 6;

		float islUEC = 0;
		float islAPA = 0;
		float ratioAPA = 0;

		int iUEC = 0;
		int iAPA = 0;

		//Objective obj;

		//TODO: MAKE SOME RANDOM IN ISLANDS
		//NEUTRAL ISLAND CAN BE THE FIRST TRY
		iUEC = floor( maxIslands * CapturedRatioUEC );
		iAPA = floor( maxIslands * CapturedRatioAPA );

		//TODO: male upravy ve vyberu pocatecnich ostrovu
		//TODO: Zmenit vyber stockpile-u		
		if ( iUEC < 1 ) iUEC = 1;
		if ( iAPA < 1 ) iAPA = 1;

		string startingIslands[2] = { "", "" };
		float min = 0;
		float max = 0;

		int rSide = rand( 0,1 );
		for ( int y = 0; y < allIslands; y++ )
		{
			IslandModel islandI= g_Game.GetIsland(y);
			vector pos = islandI.GetStrategyPos();

			float posX = pos[rSide];
			if ( posX < min )
			{
				min = posX;
				startingIslands[0] = islandI.GetName();
			}

			if ( posX > max )
			{
				max = posX;
				startingIslands[1] = islandI.GetName();
			}
		}

		IslandModel startIsland;

		if ( iUEC < iAPA )
		{
			startIsland = g_Game.FindIslandByName( startingIslands[0] );
			InitPlayersNetwork( startIsland, PlayerUEC, iUEC);
			startIsland = g_Game.FindIslandByName( startingIslands[1] );
			InitPlayersNetwork( startIsland, PlayerAPA, iAPA);
		}
		else
		{
			startIsland = g_Game.FindIslandByName( startingIslands[0] );
			InitPlayersNetwork( startIsland, PlayerAPA, iAPA);
			startIsland = g_Game.FindIslandByName( startingIslands[1] );
			InitPlayersNetwork( startIsland, PlayerUEC, iUEC);
		}

		//---------------------Set Islands Types----------------------------
		for ( y = 0; y < allIslands; y++ )
		{
			f = frand(0,1);
			island = g_Game.GetIsland(y);

			if ( f < 1 ) island.SetType( IslandFactory );
			if ( f < 0.66 ) island.SetType( IslandMine );
			if ( f < 0.2 ) island.SetType( IslandDefence );
		}

		GameProduction prodUEC = PlayerUEC.GetProduction();
		GameProduction prodAPA = PlayerAPA.GetProduction();

		prodUEC.EnableWork( true );
		prodUEC.EnableSupplies( true );
		prodAPA.EnableWork( true );

		//Enable blueprint if is his tech level is smaller or equal the tech level from init screen
		for( int n = 0; n < sizeof( ITEMS ) ; n++ )
		{
			GameProductionItem item = prodUEC.GetItem( ITEMS[n] );
			prodAPA.Enable( ITEMS[n] );

			if ( ITEMS[n] == wMantaTorpedo || ITEMS[n] == upgradeMantaShield || ITEMS[n] == wWalrusHowitzer || ITEMS[n] == wWalrusLauncher )
				continue;

			if ( StartingTechLevel >= item.GetTechLevel() )
				prodUEC.Enable( ITEMS[n] );
			else
			{
				if ( item.GetTechLevel() < 3 )
				{
					Blueprints[ BlueprintsCnt ] = ITEMS[n];
					BlueprintsCnt++;
				}
			}
		}

		//Enable green laser if he found it in Gaea Campaign
		if ( g_Achievements.IsAchieved( AchieveSpecialBlueprint ) )
		{
			Blueprints[ BlueprintsCnt ] = wWalrusLaserGreen;
			BlueprintsCnt++;	
		}

		//Enable blueprints of carrier weapons
		if ( StartingTechLevel < 1 )
		{
			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierFrontPlasma;
				BlueprintsCnt++;
			}
		}

		if ( StartingTechLevel < 2 )
		{

			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierLeftGatling;
				BlueprintsCnt++;
			}

			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierRightGatling;
				BlueprintsCnt++;
			}

			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierRearLeftGatling;
				BlueprintsCnt++;
			}

			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierRearRightGatling;
				BlueprintsCnt++;
			}
		}

		if ( StartingTechLevel < 2 )
		{
			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierLeftLaser;
				BlueprintsCnt++;
			}

			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierRightLaser;
				BlueprintsCnt++;
			}

			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierRearLeftLaser;
				BlueprintsCnt++;
			}

			if ( BlueprintsCnt < sizeof( Blueprints ) )
			{
				Blueprints[ BlueprintsCnt ] = wCarrierRearRightLaser;
				BlueprintsCnt++;
			}
		}
		
		if ( StartingTechLevel >= 1 )
		{
			prodUEC.Enable( wCarrierFrontPlasma );
			
			prodUEC.Enable( wCarrierLeftGatling );
			prodUEC.Enable( wCarrierRightGatling );
			prodUEC.Enable( wCarrierRearLeftGatling );
			prodUEC.Enable( wCarrierRearRightGatling );
		}


		if ( StartingTechLevel >= 2 )
		{
			prodUEC.Enable( wCarrierLeftLaser );
			prodUEC.Enable( wCarrierRightLaser );
			prodUEC.Enable( wCarrierRearLeftLaser );
			prodUEC.Enable( wCarrierRearRightLaser );
		}

		//if player wants everything
		if ( StartingTechLevel == 3 )
		{
			prodUEC.Enable( wMantaTorpedo );
			prodUEC.Enable( upgradeMantaShield );
			prodUEC.Enable( wWalrusHowitzer );
			prodUEC.Enable( wWalrusLauncher );
			prodUEC.Enable( wCarrierFrontShell );
			prodUEC.Enable( wCarrierLeftFlak );
			prodUEC.Enable( wCarrierRightFlak );
			prodUEC.Enable( wCarrierRearLeftFlak );
			prodUEC.Enable( wCarrierRearRightFlak );
			prodUEC.Enable( wCarrierHammerHead );

			prodUEC.Enable( upgradeWalrusShield );
			prodUEC.Enable( wCarrierLeftLaser );
			prodUEC.Enable( wCarrierRightLaser );
			prodUEC.Enable( wCarrierRearLeftLaser );
			prodUEC.Enable( wCarrierRearRightLaser );
			prodUEC.Enable( wCarrierFrontMissile );
			prodUEC.Enable( wMantaLaserGreen );


			if ( g_Achievements.IsAchieved( AchieveSpecialBlueprint ) )
				prodUEC.Enable( wWalrusLaserGreen );

			BlueprintsCnt = 0;
		}

		prodAPA.Enable( genericArmor );
		prodAPA.Enable( genericLightWeapon );
		prodAPA.Enable( genericHeavyWeapon );
		prodAPA.Enable( genericSupport );

		CampaignLog("[CC:Classic] >>> Blueprints Enabled", 1);

		//randomize array of blueprints
		int indexI;
		int temp;
		int tempInt;
		for( int l = 0; l < BlueprintsCnt; l++ )
		{
			indexI = rand( 0, BlueprintsCnt );
			temp = Blueprints[indexI];
			Blueprints[indexI] = Blueprints[l];
			Blueprints[l] = temp;
		}

		//distribute blueprints over islands
		for( int tst = 0; tst < g_Game.GetNumIslands(); tst++)
		{
			IslandModel islandNew = g_Game.GetIsland(tst);
			if ( islandNew.GetPlayer() != PlayerUEC )
			{
				BlueprintsIslands[ BlueprintsIslandsCnt ] = islandNew.GetName();
				BlueprintsIslandsCnt++;
			}
			if ( BlueprintsIslandsCnt >= BlueprintsCnt )
				break;
		}
		
		int oldIsland = 0;
		while( BlueprintsIslandsCnt < BlueprintsCnt )
		{
			BlueprintsIslands[ BlueprintsIslandsCnt ] = BlueprintsIslands[ oldIsland ];
			BlueprintsIslandsCnt++;
			oldIsland++;
		}


//Just for debug
/*
		int islandIndex = 0;
		string firstIsland = BlueprintsIslands[0];
		while( islandIndex < BlueprintsCnt )
		{
			string islB = BlueprintsIslands[islandIndex];
			string itemsOnIsland = "";
			itemsOnIsland = islB + ":::";
			if ( islandIndex != 0 && islB == firstIsland )
				break;
			
			for( tst = 0; tst < sizeof( BlueprintsIslands ); tst++)
			{
				string islName = BlueprintsIslands[ tst ];
				if ( islName == "" )
					break;
	
				if ( islB == islName )
				{
					itemsOnIsland += g_Game.ArticleName(Blueprints[tst]) ;
					itemsOnIsland += " ,";
				}
			}
			islandIndex++;
			CampaignLog( itemsOnIsland, 5 );
		}
*/
//<------Just for debug

		//TEMP: create strategic AI here
		PlayerUEC.CreateStrategicAI( true );
		PlayerAPA.CreateStrategicAI( false );

		PlayerAPA.SetSkill( EnemyStrength );

		PlayerAPA.SetUpgradeFlags( EUPGRADE_M_ALL | EUPGRADE_W_ALL );
		PlayerUEC.SetUpgradeFlags( EUPGRADE_M_ALL | EUPGRADE_W_ALL );

		float resourceValue = 0;
		if ( ResourcesRatio > 0.5 )
			resourceValue = ResourcesRatio * 2;

		if ( ResourcesRatio <= 0.5 )
			resourceValue = LerpFloats( 0.5, 1, ResourcesRatio );

		float incomeValue = 0;
		if ( IncomeRatio > 0.5 )
			incomeValue = IncomeRatio * 2;

		if ( IncomeRatio <= 0.5 )
			incomeValue = LerpFloats( 0.5, 1, IncomeRatio );
			
		prodUEC.SetMiningScale( incomeValue );
		prodUEC.SetProductionScale( incomeValue );
		prodUEC.SetStockpileScale( incomeValue );
		prodAPA.SetMiningScale( incomeValue );
		prodAPA.SetProductionScale( incomeValue );
		prodAPA.SetStockpileScale( incomeValue );
		PlayerNeutral.GetProduction().SetMiningScale( incomeValue );
		PlayerNeutral.GetProduction().SetProductionScale( incomeValue );
		PlayerNeutral.GetProduction().SetStockpileScale( incomeValue );

		prodUEC.IncreaseResources( 1500 * iUEC * resourceValue );
		prodAPA.IncreaseResources( 1500 * iAPA * resourceValue );

		CampaignLog("[CC:Classic] >>> Production Enabled", 1);

		g_Game.LoadIslandWorld( LastAssignedIslandUEC.GetName() );

		// enable all islands visibility
		g_Game.EnableIslandsOnMap(true);
		//Enable Manual carrier drive
		PlayerUEC.EnableCarrierManual( true );

		OnEnterCampaignCommon();

/*
		//Todo: Remove after testing
		IslandModel islTest = g_Game.FindIslandByName( "Acheron" );
		islTest.AssignToPlayer( PlayerAPA, true );
		islTest.SetType( IslandDefence );
*/
		SetCurrentTask( true );

		return true;
	}

	void OnBuildShieldRaised( Building pBuilding )
	{
		if ( pBuilding == g_Game.GetCommandCenter() )
		{
			GameEntity entity = PlayerUEC.GetNextWaypoint();
			if ( entity != NULL )
			{
				if ( pBuilding == entity )
					PlayerUEC.ClearWaypoint();
			}

			if ( g_Game.GetCurrentIsland().IsBuildingCommandCenterForPlayer() )
			{
				IslandModel island = g_Game.GetCurrentIsland();
				Objective objCurrent = GetIslandObjective( q_ClassicCampaign, island);

				if ( objCurrent != NULL )
				{
					Objective objMission = objCurrent.GetSubObjective( 1 );
					SetCurrentTask( true );
					objMission.SetStatus( OBJECTIVE_COMPLETE );
				}
			}
		}
	}


	//! Called before campaign world load, handling mission (entity) spawning here
	void OnBeforeWorldLoad( IslandModel pIsland )
	{
		g_Game.GetPlayer(1).EnableIslandUnitControl(true);
		//Calculate proper ForceMultiplier
		//-----------------------------------------------------
		//if ( !CampaignStart ) CalculateTechLevel( pIsland );

		GameProduction prodAPA = PlayerAPA.GetProduction();

		if ( pIsland == NULL )
			return;

		//spawn classic layer in classic campaign
		//----------------------------------------------------
		if ( SPAWN_CURRENT_LAYER )
			g_Game.SetSpawnLayer( CURRENT_LAYER );
		else
		{
			string islName = pIsland.GetName();
			string temp = islName + "_Classic";
			int sLayer;

			if ( GetValue(NULL, temp , 0, sLayer) )

			g_Game.SetSpawnLayer( sLayer );
		}

		MultiForce = GetIslandForceMod( pIsland );
		TechLvl = GetIslandTechLevel( pIsland );
		UnitSkill = GetIslandUnitSkill( pIsland );
		UnitSkillRange = GetIslandUnitSkillRange( pIsland );

		if ( pIsland.GetPlayer() == PlayerAPA )
			pIsland.UniPostRestore();


		dlg_CTSV_Firewalls_EndFail.ClearFinishedFlag();
		dlg_CTSV_Firewalls_Found.ClearFinishedFlag();
		if ( didrone )
			{
			diPlayerUEC.GetCarrierStorage().RemoveItem( DroneScanner, diPlayerUEC.GetCarrierStorage().GetItemCount( ts ) );
			diPlayerUEC.GetCarrierStorage().RemoveItem( ts, diPlayerUEC.GetCarrierStorage().GetItemCount( ts ) );
			}
	}


	//! Called during campaign world load ( between OnBeforeWorldLoad and OnAfterWorldLoad )
	void OnProcessWorldLoad( IslandModel pIsland )
	{
		if ( !pIsland )
			return;
	}

	//! Called after all entities and textures a fully loaded
	int OnAfterWorldLoad( IslandModel pIsland )
	{
		CampaignLog( "[CC:Classic] >>> ---------------------------------------------------------------", 5 );
		CampaignLog( "[CC:Classic] >>> OnAfterWorldLoad()" );
		if ( !g_Game.IsClient() )
		{
			if ( !pIsland )
			{
				CampaignLog("[CC:Classic] >>> Cutscene world... skipping initialization", 2 );
				return 1;
			}
			else
				PlayAmbientIslandMusic( pIsland );

			if ( pIsland.GetPlayer() == PlayerAPA )
				SpecialCaseAdvisorWeather();

			string cc_classic = "[CC:Classic] >>> Entering island map: '";
			cc_classic += CurrentIslandName;
			cc_classic += "'...";
			CampaignLog( cc_classic, 4 );
			
			actionQueue.OnAfterWorldLoad(CurrentIslandName);
			// we need set up slot activation when we entering new island
			if ( !g_Game.InCutscene() )
			{
				Building slot = g_Game.GetMainSlotBuilding();
				if ( slot )
				{
					Activator activator = slot.GetActivator();
					if ( activator )
						SlotActivatorInit( activator, pIsland.GetName() )

 					if ( pIsland.GetPlayer() == PlayerAPA )
 					{
						int bType = slot.GetBuildingType();
						if ( bType == BuildingFactory )
							RandomItem = PrepareRandomItem( ItemsGroupFactory );

						if ( bType == BuildingRefinery )
							RandomItem = PrepareRandomItem( ItemsGroupRafinery );

						if ( bType == BuildingHeadQuarters )
							RandomItem = PrepareRandomItem( ItemsGroupDefense );
					}
				}

 				if ( pIsland.GetPlayer() == PlayerNeutral )
				{
					CommandCenter cc = g_Game.GetCommandCenter();
					if ( cc != NULL && cc.WasDiscovered() )
						PlayerUEC.SetNextWaypoint("#mission_cc_wp", cc );
				}

 				if ( pIsland.GetPlayer() == PlayerUEC )
				{
					if ( g_Game.GetCommandCenter() != NULL )
						g_Game.GetCommandCenter().DisableUse();
				}
				else
				{
					//!! SET MISSION AS PENDING IF ISN'T YET                                   
					//-----------------------------------------------------------------
					Objective objCurrent = GetIslandObjective( q_ClassicCampaign, pIsland);
					if ( objCurrent != NULL )
					{
						Objective missionObj;
						if ( pIsland.GetPlayer() == PlayerAPA )
						{
							SetCurrentTask( false );
							missionObj = objCurrent.GetSubObjective(0);
						}
						else
							missionObj = objCurrent.GetSubObjective(1);
						
						if ( missionObj != NULL )
						{
							missionObj.SetStatus( OBJECTIVE_UNAVAILABLE );

							if ( missionObj.GetTitle() != "NO GENERIC MISSION" )
								missionObj.SetStatus( OBJECTIVE_PENDING );
						}
					}
				}

				//Call init method on campaign start
				if ( CampaignStart )
					CampaignClassicInit( pIsland );
					
				//------------------------------------------------------------------------------
				if ( SelectCarrierAfterLoad )
				{
					PlayerUEC.GetCarrier().SelectForPlayer();
					SelectCarrierAfterLoad = false;
				}
			}
		}
		CampaignLog( "[CC:Classic] >>> ---------------------------------------------------------------", 5 );
		return 1;
	}
	
	//! Action from action queue was started
	void OnQueueActionStarted(QueueAction action)
	{
	}

	//! Action from action queue was finished
	void OnQueueActionFinished(QueueAction action)
	{
		if ( action == dlg_CTSV_Firewalls_EndFail )
		{
			if ( IslandsUEC > IslandsAPA)
			{
				SetCurrentObjective( q_RedDragon );
				SetCurrentObjectiveShiplog( q_RedDragon );
			}
			else
			{
				SetCurrentObjective( q_ClassicCampaign );
				SetCurrentObjectiveShiplog( q_ClassicCampaign );
			}
		}
	}

	//! On Actor direct death
	void OnActorDeath( InteractiveEntity pActor )
	{
 	}

	//! On Actor driven unit death
	void OnActorDrivenUnitDeath( InteractiveEntity pDrivenUnit, InteractiveEntity pActor )
	{
		CampaignLog( "[CC:Classic] >>> OnActorDrivenUnitDeath - just dropActor.", 3 );
		pDrivenUnit.DropActor();
	}

	//! When torpedo hits target
	void OnTorpedoHitTarget( Projectile pTorpedo, InteractiveEntity pTarget )
	{
		if ( pTarget == NULL )
			return;

		float death;
		if ( PlayerAPALives > 1 )
			death = 0.05;
		else
			death = 0;

		if ( IsInherited( pTarget,Type("Carrier")) )
		{
			Carrier carrier = pTarget;

			InteractiveRepairZone rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_MANTALIFTS );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.5, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_WALRUSLEFT );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.15, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_WALRUSRIGHT );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.15, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_CRUISEMISSILE );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.5, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_CONTROLTOWER );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.5, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_DEFENSE );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.5, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_OFFENSE );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.5, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_SUPERSTRUCTURE );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.4, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_ENGINES );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.25, true);
			else
				rz.SetHealth( 0.04, true);

			rz =  carrier.GetLocalRepairZone( ECARRIER_ZONE_REPAIRSYSTEM );
			if ( rz.GetHealth() > 0.7 )
				rz.SetHealth( 0.5, true);
			else
				rz.SetHealth( 0.04, true);
				
//			carrier.Damage( 0.01 );
		}
	}

	//! New objective was given to the player
	void OnObjectiveAdded( Objective obj )
	{
		if ( BanGameMessage || diskipadvisor )
			return;

		if ( !CampaignStart )
			g_Game.PlayGameSound( "ui/NewObjective" );

		if ( obj.IsOptional() )
			g_Game.AddMessage( "#obj_objective_new_optional" , COLOR_WHITE, LMF_EMPIRE, obj.GetTitle() );
		else
			g_Game.AddMessage( "#obj_objective_new" , COLOR_WHITE, LMF_EMPIRE, obj.GetTitle() );
	}

	//! Player fails to finish the objective
	void OnObjectiveFailed( Objective objective )
	{
		if ( BanGameMessage )
			return;

		g_Game.AddMessage( "#obj_objective_failed" , COLOR_WHITE, LMF_EMPIRE, objective.GetTitle() );
	}

	//! Player successfuly finished an objective
	void OnObjectiveCompleted( local Objective o )
	{
		vector pos;
		switch( o )
		{
			//CampaignEnd1 Zniceni Carrieru
			case q_RedDragon:
				if ( !CampaignEnd1 )
					EndOfTheGameClassic = false;
				else
				{
					if ( !CampaignEnd2 )
						EndOfTheGameClassic = true;
					else
					{
						if ( IsObjectiveCompleted( q_ClassicCampaign) )
							EndOfTheGameClassic = true;
					}
				}
				int climate = g_Game.GetCurrentIsland().GetClimateType();
				switch( climate )
				{
					case Wastelands:
						LastSkyPreset = "Wastelands_C";
						break;
		
					case Temperate:
						LastSkyPreset = "Temperate_C";
						break;
		
					case Mountains:
						LastSkyPreset = "Mountains_C";
						break;
		
					case Marshes:
						LastSkyPreset = "Marshes_C";
						break;
		
					case Icelands:
						LastSkyPreset = "Icelands_C";
						break;
		
					case Volcanic:
						LastSkyPreset = "Volcanic_C";
						break;
				}

				WhichTimeToSetClassic = g_Game.GetDayTime();
				WhichWeatherToSetClassic = g_Game.GetCurrentIsland().GetWeather();
				WhichWorldToLoadClassic = g_Game.GetCurrentIsland().GetName();
				#ifdef CONSOLE
					g_Game.LoadCutScene("worlds/ctsc_CarrierDestroyedClassic_video.ent");
				#else
					g_Game.LoadCutScene("worlds/ctsc_CarrierDestroyedClassic.ent");
				#endif	
				break;
			
			case q_ClassicCampaign:
				pos = PlayerUEC.GetCarrier().GetPosition();

				if ( CampaignEnd2 )
				{
					FINAL_CUTSCENE = g_Game.PlayCutsceneOnPos("cutscenes/unitlostCarrier.cut", pos, CPM_LOOP, false, false);
					if ( !CampaignEnd1 )
						g_Game.OnGameOver(1000, "#strat_game_end1", true);	//run game over process. call this as last					
					else
					{
						if ( IsObjectiveCompleted( q_RedDragon ) )
							g_Game.OnGameOver(1000, "#strat_game_end1", true);	//run game over process. call this as last
						else
							g_Game.ShowDialog( "#strat_game_endcontinue_title", "#strat_game_endcontinue_desc", CAMPAIGN_END, DBT_YESNO, DBB_YES, DMT_QUESTION )
					}
				}
				break;
		}

		if ( BanGameMessage || diskipadvisor )
			return;

		g_Game.AddMessage( "#obj_objective_complete" , COLOR_GREEN, LMF_EMPIRE, o.GetTitle() );
	}

	//! Called when players carrier enter timewarp
	bool OnEnterTimeWarp( IslandModel pCurrent, IslandModel pDestination )
	{
		dicarrsenttoisl = pDestination.GetListID() + 1;
		g_Game.PlayMusic( "music/timewarp", 50, 50, true );
		SetCurrentTask( true );
	}

	//! Carrier was destroyed ( of any player)
	void OnCarrierDestroyed( Carrier carrier )
	{
		CCPlayer player = carrier.GetPlayer();

		if ( player == PlayerAPA )
		{
			g_Game.GetCurrentIsland().OnAttackStop( PlayerAPA );
			q_RedDragon.SetStatus( OBJECTIVE_COMPLETE );

			q_ClassicCampaign.SetDescription( "#obj_classic_desc", itoa(IslandsAPA) );
		}

		if ( player == PlayerUEC )
		{
			g_Game.PlayCutsceneOnPos("cutscenes/unitlostCarrier.cut", carrier.GetPosition(), CPM_LOOP, false, false);
			g_Game.OnGameOver(300, "Your carrier was destroyed!", false);	//run game over process. call this as last
		}
	}

	//! Stockpile was lost ( by any player)
	void OnStockpileLost( IslandModel pStockpile, CCPlayer pPlayer )
	{
	if ( diskipadvisor )
		return;
		pPlayer.GetStockpileStorage().Plunder();
		
		if(pPlayer != g_Game.GetControlledPlayer())
			g_Achievements.OnEnemyStockpileCaptured();
	}

	//! Island was captured by another player or CC on island was destroyed
	void OnIslandLost( IslandModel island, CCPlayer pPlayer )
	{
/*	
		if ( pPlayer == PlayerUEC )
			IslandsUEC -= 1;

		if ( pPlayer == PlayerAPA )
			IslandsAPA -= 1;		

		int left;
		if ( IsObjectiveCompleted( q_RedDragon ))
			left = IslandsAPA;
		else
			left = g_Game.GetNumIslands() - IslandsUEC;
		q_ClassicCampaign.SetDescription( "#obj_classic_desc", itoa(left) );
*/
	}

	//! Solve island revelation
	void OnIslandRevelation( IslandModel pIsland )
	{
		bool reveal = false;
	
		if( pIsland.GetPlayer() == PlayerUEC )
		{
			reveal = true;
		}
		else
		{
			if( pIsland.IsConnectedToEnemy() )
				reveal = true;

			if( pIsland.IsBuildingCommandCenterForPlayer() )
				reveal = true;
	
			if( pIsland == g_Game.GetCurrentIsland() )
			{
				if ( PlayerUEC.GetCarrier() != NULL )
				{
					vector carPos = PlayerUEC.GetCarrier().GetPosition();
					vector islPos = pIsland.GetPosition();
					vector distVec = carPos - islPos;
					distVec[2] = 0;
					float dist = VectorLength( distVec );
					if ( dist < 256000 )
						reveal = true;
				}
			}
		}
			
		if( reveal )
			pIsland.OnRevealed();
		else
			pIsland.OnConcealed();
	}

	//! Some player build CC on island
	void OnIslandCaptured( IslandModel island, CCPlayer prevPlayer )
	{
		string islandName = island.GetName();
		string cc_classic = "[CC:Classic] >>> ";
		CCPlayer islandOwner = island.GetPlayer();
		Objective objIsl = NULL;
		Objective objMission = NULL;
		Objective objCC = NULL;

		Objective objCurrent = GetIslandObjective( q_ClassicCampaign, island);
		if ( objCurrent != NULL )
		{
			objIsl = objCurrent;
			objMission = objCurrent.GetSubObjective(0);
			objCC = objCurrent.GetSubObjective(1);
		}

		if ( !CampaignStart && islandOwner == PlayerUEC && prevPlayer != islandOwner && prevPlayer == PlayerAPA && !diskipadvisor )
			g_Achievements.OnIslandCaptured( GenericDefenseLevel( island, GetGlobalForceMultiplier() ) );

		if ( !CampaignStart )
		{
			if ( prevPlayer == PlayerUEC )
				IslandsUEC -= 1;

			if ( prevPlayer == PlayerAPA )
				IslandsAPA -= 1;
		}

		//             Captured By APA                                   
		//--------------------------------------------------
		if ( islandOwner == PlayerAPA )
		{
			cc_classic = "Ostrov: " + island.GetName() + " byl obsazen APA hracem."
			CampaignLog( cc_classic, 7 );
			IslandsAPA += 1;

			if ( island != g_Game.GetCurrentIsland())
				island.UniPostRestore();

			island.SetOwnershipMark( g_Game.GetCampaignDays() );

			if ( objIsl != NULL )
			{
				objIsl.SetStatus( OBJECTIVE_UNAVAILABLE );
				objIsl.SetStatus( OBJECTIVE_PENDING );

				if ( CampaignEnd2 && q_ClassicCampaign.GetStatus() == OBJECTIVE_COMPLETE )
				{
					q_ClassicCampaign.SetStatus( OBJECTIVE_PENDING );
				}

				if ( objCC != NULL && objCC.GetStatus() == OBJECTIVE_PENDING )
					objCC.SetStatus( OBJECTIVE_UNAVAILABLE );

				if ( objMission != NULL)
				{
					objMission.SetStatus( OBJECTIVE_UNAVAILABLE );
					IslandModel neighbors[8];
					int neighCount = 0;
					island.GetConnectedNeighbors( neighbors, neighCount );
					for( int i = 0; i < neighCount; i++ )
					{
						IslandModel isl = neighbors[i];
						if ( isl != NULL )
						{
							if ( isl.GetPlayer() == PlayerUEC )
							{
								if ( isl.IsConnectedToStockpile() && objMission.GetTitle() != "NO GENERIC MISSION" )
								{
									objMission.SetStatus( OBJECTIVE_PENDING );
									break;
								}
							}
						}
					}
				}
			}

			SlotRestoration( island.GetName() );

			//just tell player island is lost
			if ( prevPlayer == PlayerUEC && !diskipadvisor )
			{
				int ra = rand(0,25);
				if ( ra < 5 )
					dlg_gen_islandlost_okoro_ver_01.ToQueue();
				else
				{
					if ( ra < 10 )
						dlg_gen_islandlost_okoro_ver_02.ToQueue();
					else
					{
						if ( ra < 15 )
							dlg_gen_islandlost_okoro_ver_03.ToQueue();
						else
						{
							if ( ra < 20 )
								dlg_gen_islandlost_okoro_ver_04.ToQueue();
							else
								dlg_gen_islandlost_okoro_ver_05.ToQueue();
						}
					}
				}
			}
		}

		//             Captured By UEC                                   
		//--------------------------------------------------
		if( islandOwner == PlayerUEC )
		{
			if (!diskipadvisor)
				{
				diislcap++;
				diprogressunlock();
				}
			int r;
			cc_classic += "Ostrov: " + island.GetName() + " byl obsazen UEC hracem."
			CampaignLog( cc_classic, 7 );
			IslandsUEC += 1;

			// specific veci po obsazeni hackem, ne buildem CC   
			//-------------------------------------------------
			if ( island == g_Game.GetCurrentIsland() )	
			{
				if ( !CampaignStart && !diskipadvisor )
					PlayIslandCaptured();

				PlayerUEC.ClearWaypoint();
				SetCurrentTask( true );
			}
			else
			{
				if ( !CampaignStart && !diskipadvisor )
					PlayIslandCapturedDistant();
			}

			//Splneni mise na tomto ostrove
			if ( objIsl != NULL )
			{
				if ( CampaignStart )
					objIsl.SetStatus( OBJECTIVE_UNAVAILABLE );
				else
					objIsl.SetStatus( OBJECTIVE_COMPLETE );

				if ( objCC != NULL && objCC.GetStatus() != OBJECTIVE_UNAVAILABLE )
					objCC.SetStatus( OBJECTIVE_UNAVAILABLE );

				if ( objMission != NULL && objMission.GetStatus() != OBJECTIVE_UNAVAILABLE )
					objMission.SetStatus( OBJECTIVE_UNAVAILABLE );					
			}

			//PROZRAZENI MISE NA OKOLNICH OSTROVECH
			neighbors[8];
			neighCount = 0;
			island.GetConnectedNeighbors( neighbors, neighCount );
			//projdi sousedy
			for( int x = 0; x < neighCount; x++ )
			{
				IslandModel islX = neighbors[x];
				if ( islX == NULL )
					continue;

				if ( islX.GetPlayer() == PlayerAPA )
				{
					//pokud je soused APA prozrad misi ktera na nem je
					Objective objNeigh = GetIslandObjective( q_ClassicCampaign, islX );
					Objective missionObj = objNeigh.GetSubObjective( 0 );
					if ( missionObj.GetTitle() != "NO GENERIC MISSION" )
					{
						missionObj.SetStatus( OBJECTIVE_UNAVAILABLE );
						missionObj.SetStatus( OBJECTIVE_PENDING );
					}
				}
			}


			if ( BlueprintsCnt > 0 )
			{
				//Enable blueprint when player capture island with blueprint
				for ( int f = 0; f <= BlueprintsIslandsCnt; f++)
				{
					string islN = BlueprintsIslands[f];
					if (	islandName == islN )
					{
						//Give APA carrier better Weapons when player find a blueprint of that weapon
						//with "random" placement
						Carrier carrier = PlayerAPA.GetCarrier();
						if ( carrier != NULL && carrier.GetHealth() > 0 )
						{
							if ( Blueprints[f] == wCarrierLeftFlak )
								carrier.AddEquipment( wCarrierRearRightFlakEnemy );
							if ( Blueprints[f] == wCarrierRightFlak )
								carrier.AddEquipment( wCarrierLeftFlakEnemy );
							if ( Blueprints[f] == wCarrierRearLeftFlak )
								carrier.AddEquipment( wCarrierRightFlakEnemy );
							if ( Blueprints[f] == wCarrierRearRightFlak )
								carrier.AddEquipment( wCarrierRearLeftFlakEnemy );

							carrier.EnableItems();
						}

						EnableProductionEx( PlayerUEC, Blueprints[f] );
						BlueprintsIslands[f] = "";
					}
				}
			}

			//ROLL FOR NEW MISSION ON ISLAND
			//Vyber pristi nahodne mise
			island.UniPostClear();
			f = rand( 0,3 );
			if ( f == island.GetUniPostMission() )
			{
				f -= 1;	
				if ( f < 1 )
					f = 3;
			}

			string mis = "[CC:CC_CAMPAIGN] >>> "
			mis += "Set mission texts (Title and Description): " + " Nova mise je: ";

			mis += SetMissionsTexts( objMission, f, island );

			CampaignLog( mis, 7 );
			island.UniPostClear();
		}

		cc_classic = "[CC:Classic] >>> Ostrovy patrici UEC strane: ";
		cc_classic += itoa( IslandsUEC );
		CampaignLog( cc_classic, 5 );

		cc_classic = "[CC:Classic] >>> Ostrovy patrici APA strane: ";
		cc_classic += itoa( IslandsAPA );
		CampaignLog( cc_classic, 5 );

		int left;
		if ( IsObjectiveCompleted( q_RedDragon ) )
		{
			left = IslandsAPA;
			if ( left == 0 && !CampaignStart )
			{
				CampaignLog( "[CC:Classic] >>> UEC ma vsechny APA ostrovy a APA Carrier neni - ukonci to!" , 5 );
				q_ClassicCampaign.SetStatus( OBJECTIVE_COMPLETE );
				g_Achievements.OnEnemyEmpireCaptured();
				return;
			}
		}
		else
			left = g_Game.GetNumIslands() - IslandsUEC;

		q_ClassicCampaign.SetDescription( "#obj_classic_desc", itoa(left) );
	}

	//! When player captures all islands
	void OnAllIslandsCaptured()
	{
			CampaignLog( "[CC:Classic] >>> UEC ma vsechny ostrovy - ukonci to!" , 5 );
			q_ClassicCampaign.SetStatus( OBJECTIVE_COMPLETE );
			g_Achievements.OnEnemyEmpireCaptured();
			SetCurrentTask( true );
	}

	//! Called when some building is destroyed
	void OnBuildingDestroy( Building pBuilding )
	{
		GenericBuildingDestroyed( pBuilding );
		if ( pBuilding == g_Game.GetCommandCenter() )
		{
			IslandModel island = g_Game.GetCurrentIsland();
			if ( island.GetPlayer() == PlayerNeutral )
			{
				Objective objCurrent = GetIslandObjective( q_ClassicCampaign, island);
				if ( objCurrent != NULL )
				{
					if ( island.GetPlayer() != PlayerUEC )
					{
						Objective objRand = objCurrent.GetSubObjective(0);
						Objective objCC = objCurrent.GetSubObjective(1);

						objCurrent.SetStatus( OBJECTIVE_UNAVAILABLE );
						objCurrent.SetStatus( OBJECTIVE_PENDING );
						objRand.SetStatus( OBJECTIVE_UNAVAILABLE );
						objCC.SetStatus( OBJECTIVE_UNAVAILABLE );
						objCC.SetStatus( OBJECTIVE_PENDING );
						SetCurrentObjective(objCC);
						SetCurrentObjectiveShiplog(objCC);

					}
				}
			}
		}
	}

	//! Called when specific (with activator) building was hacked
	void OnBuildingHacked( Building pBuilding, CCPlayer pByPlayer )
	{
		int bType = pBuilding.GetBuildingType();
		Activator activator = pBuilding.GetActivator();

		if ( bType == BuildingFactory )
		{
			if ( activator )
				SlotActivatorUsed( activator, g_Game.GetCurrentIsland().GetName() )
			AddRandomItem( RandomItem );
		}

		if ( bType == BuildingRefinery )
		{
			if ( activator )
				SlotActivatorUsed( activator, g_Game.GetCurrentIsland().GetName() )
			AddRandomItem( RandomItem );
		}

		if ( bType == BuildingHeadQuarters )
		{
			if ( activator )
				SlotActivatorUsed( activator, g_Game.GetCurrentIsland().GetName() )
			AddRandomItem( RandomItem );
		}

		GenericBuildingHacked( pBuilding, pByPlayer );
	}

	//! Player units discovereD entity on map
	void OnDiscovered( InteractiveEntity entity )
	{
		GenericOnDiscovered( entity );
	}

	//! Called when player close message dialog
	void OnModalResult( int dialogID, int result )	//result values: 	DBB_OK, DBB_YES, DBB_NO
	{
		switch( dialogID )
		{
			case CAMPAIGN_END:
			{
				if ( result == DBB_YES )
				{
					if ( g_Game.IsCutscenePlaying( FINAL_CUTSCENE ) )
					{
						g_Game.StopCutscene( FINAL_CUTSCENE );
						//FIX 29.11. Don't remove enemy carrier when player wants to hunt him ... :(
						//PlayerAPA.RemoveCarrier();
					}

					g_Game.GetControlledPlayer().GetCarrier().SelectForPlayer();
					SetCurrentTask( true );
				}

				if ( result == DBB_NO )
					g_Game.OnGameOver(500, "#strat_game_endgen", true);	//run game over process. call this as last
				break;	
			}
		}
	}

	//! Called before game is saved
	void OnBeforeSave()
	{
		OnBeforeSaveBase();
	}

	//! Called after game is loaded from save
	void OnAfterLoad()
	{
		OnAfterLoadBase();
		// set global pointers for production
		GainProduction();
	}

	//! Callback to game code - median unit skill
	float GetUnitSkill()
	{
		return UnitSkill;
	}

	//! Callback to game code - unit skill range (returned number will form an interval along with the above func)
	float GetUnitSkillRange()
	{
		return UnitSkillRange;
	}

	//! Callback to game code - current power multiplier
	float GetGlobalForceMultiplier()
	{
		return MultiForce;
	}

	//! Callback to game code - current preferred tech level
	int GetCurrentTechLevel()
	{
		return TechLvl;
	}

	//! Fill up objectives in IslandInfo Screen (called when this screen have to show up)
	int GetIslandObjectives(IslandModel island, Objective objectives[32])
	{
		int numObjectives = 0;
		int classicObjectives = q_ClassicCampaign.GetSubObjectivesCount();
		string islandName = island.GetName();
		strlower( islandName );

		Objective objCurrent = GetIslandObjective( q_ClassicCampaign, island);
		if ( objCurrent != NULL )
		{
			objectives[numObjectives++] = objCurrent;
			if ( island.GetPlayer() != PlayerUEC )
			{
				int islObjectives = objCurrent.GetSubObjectivesCount();
				if ( islObjectives > 0 )
				{
					for( int c = 0; c < islObjectives; c++ )
					{
						Objective isl = objCurrent.GetSubObjective( c );
						objectives[numObjectives++] = isl;
					}
				}
			}
		}

		return numObjectives;
	}

	//! Something is happen to UniPost ( was destroyed, hacked, build up )
	void OnUniPostEvent( UniPost pUniPost, int eEvent, int iRemain, int iTotal )
	{
		Objective objMission = NULL;
		IslandModel island = g_Game.GetCurrentIsland();

		Objective objCurrent = GetIslandObjective( q_ClassicCampaign, island);
		if ( objCurrent != NULL )
		{
			int islObjectives = objCurrent.GetSubObjectivesCount();
			if ( islObjectives > 0 )
			{
				for( int c = 0; c < islObjectives; c++ )
				{
					Objective objTmp = objCurrent.GetSubObjective( c );
					if ( objTmp.GetStatus() == OBJECTIVE_PENDING )
					{
						objMission = objTmp;
						break;
					}
					else
					{
						if ( island.GetUniPostMission() == MISSION_NOTSET )
						{
							objMission = objTmp;
							break;	
						}
					}
				}
			}
		}

		GenericUnipostMission( pUniPost, eEvent, iRemain, iTotal, objMission );
	}

	//! Called when carrier storage recieves some items
	void OnCarrierStorage( int eStorageType, int eDBEnum, int iCount )
	{
		if ( BanGameMessage )
			return;
		
		if ( eStorageType == EGAMESTORAGE_BARQUE || eStorageType == EGAMESTORAGE_OBJECTIVE || eStorageType == EGAMESTORAGE_STOCKPILE )
		{
			if ( IsItemCarrierEquipment( eDBEnum ) )
				g_Game.GetControlledPlayer().GetCarrier().AddEquipment( eDBEnum );

			disetarticlename( eDBEnum );
			if ( iCount > 1 )
				diarticlename += " x" + itoa( iCount );
			if ( eStorageType != EGAMESTORAGE_STOCKPILE )
				g_Game.AddMessage("#item_was_added_carrier", COLOR_YELLOW, LMF_EMPIRE, diarticlename );
		}
	}

	//! Called when item is produced and transfered to players stockpile storage
	void OnItemProduced( int eDBEnum, int iCount )
	{
		diadvqueue();
		//check for storage space was added coz message spaming if the items reach the max number
		int inStock = PlayerUEC.GetStockpileStorage().GetItemCount( eDBEnum );
		if ( inStock < 99 )
		{
			g_Game.PlayGameSound("Game/radio/strategy/production_complete" );
			disetarticlename( eDBEnum );
			g_Game.AddMessage( "#item_was_created" , COLOR_YELLOW, LMF_EMPIRE, diarticlename );
			g_Achievements.OnItemProduced(iCount);
		}
		if ( distockpile == dicurrentisland2 && dicarruec && diloadedisland == g_Game.GetIsland(distockpile).GetName() )
			distockpilegunfix();
	}

	//! Called when players carrier leaves TimeWarp
	bool OnLeaveTimeWarp( IslandModel pCurrent, IslandModel pDestination )
	{
		g_Game.StopMusic( 200 );
		return true;
	}

	//! Carrier arrived to destination island
	bool OnCarrierReachedDestination( IslandModel pCurrent, IslandModel pDestination )
	{
		if ( pCurrent.GetPlayer() == PlayerAPA )
		{
			//RESET RANDOM MISSION IF NEEDED
			//-----------------------------------------------------------------
			Objective objCurrent = GetIslandObjective( q_ClassicCampaign, pCurrent );
			if ( objCurrent != NULL )
			{
				int islObjectives = objCurrent.GetSubObjectivesCount();
				if ( islObjectives > 0 )
				{
					for( int c = 0; c < islObjectives; c++ )
					{
						Objective missionObj = objCurrent.GetSubObjective( c );
						if ( pCurrent.GetUniPostMission() > MISSION_NOTSET && missionObj.GetStatus() == OBJECTIVE_COMPLETE )
						{
							missionObj.SetStatus( OBJECTIVE_UNAVAILABLE );
							missionObj.SetStatus( OBJECTIVE_PENDING );
						}	
					}
				}
			}
		}

		return true;
	}

	//! Called when carrier is attacked
	void OnCarrierAttacked( Carrier pCarrier )
	{
		if ( pCarrier.GetPlayer() == PlayerAPA && PlayerAPALives > 0 )
		{
			EvaluatingCarrierAttack--;				//decrease lock
			if( EvaluatingCarrierAttack >= 0 )		//lock
			{
				if ( q_RedDragon.GetStatus() != OBJECTIVE_COMPLETE && pCarrier.GetHealth() < 0.2 )
				{
					//First find out if we have island to hide
					IslandModel escapeIsland = PlayerAPA.GetStockpile();
					
					if ( escapeIsland == g_Game.GetCurrentIsland() )
						escapeIsland = NULL;

					if ( escapeIsland == NULL )
					{
						//find some suitable island first goes APA island than neutral islands
						//vyber vsechny vhodne ostrovy
						int cntIsl = g_Game.GetNumIslands()
						IslandModel escapeIslands[33];
						int index = 0;
						for( int i = 0; i < cntIsl; i++)
						{
							IslandModel escapeIsl = g_Game.GetIsland( i );
							if ( escapeIsl == g_Game.GetCurrentIsland() )
								continue;
							
							if ( escapeIsl.GetPlayer() == PlayerAPA || escapeIsl.GetPlayer().GetID() == 0 )
							{
								escapeIslands[index++] = escapeIsl;
							}
						}

						//vyber uz konkretni ostrov
						if ( index > 0 )
						{
							float distMin = 0;
							for( i = 0; i < sizeof( escapeIslands ); i++ )
							{
								escapeIsl = escapeIslands[i];
								if ( escapeIsl == NULL )
									break;

								float dist = 0;
								vector iPos = escapeIsl.GetStrategyPos();
								vector c = iPos - PlayerAPA.GetCarrierBasic().GetCenter();
								dist = VectorLength( c );

								if ( dist > distMin )
								{
									distMin = dist;
									escapeIsland = escapeIsl;
								}
							}
						}
					}

					if ( escapeIsland != NULL )
					{
						PlayerAPALives--;
						Print( "Island to Hide:" );
						Print( escapeIsland.GetName() );
					}
					else
					{
						Print( "No Island to Hide - zero lives" );
						PlayerAPALives = 0;
					}

					Print(PlayerAPALives);

					if ( PlayerAPALives > 0 && !g_Game.IsCutscenePlaying( CARRIERBEATOFF_CUTSCENE ) )
					{
						if ( pCarrier )
						{
							pCarrier.SetCaptive( true );
							pCarrier.SetInvincibility( true );
						}

						vector oriCarr = pCarrier.GetOrientation();
						vector ori = Vector(oriCarr[1], oriCarr[0], oriCarr[2]);

						CARRIERBEATOFF_CUTSCENE = g_Game.PlayCutsceneOnPos("cutscenes/chapIII/ctsc_chapiii_carrierbeatoff.cut", pCarrier.GetPosition(), CPM_NORMAL, false, false, ori );
						g_Game.FadeIn( 50 );
						Sleep( 100 );
						Wait( !g_Game.IsCutscenePlaying( CARRIERBEATOFF_CUTSCENE ) )

						PlayerUEC.GetCarrier().SelectForPlayer();

						//Znic APA jednotky na konci cutsceny
						EntityBasic assemblies[8];
						int arraySize = PlayerAPA.GetAssemblies( assemblies );
		
						for( int xLoop = 0; xLoop < arraySize; xLoop++ )
						{
							EntityBasic assembly = assemblies[xLoop];
							if ( assembly != NULL )
							{
								if ( assembly.IsWalrus() || assembly.IsManta() )
								{
									InteractiveEntity pEntity = assembly.GetEntity();
									if ( pEntity )
										pEntity.Destroy();
								}
							}
						}


						if ( pCarrier )
						{
							pCarrier.OnToDockPoint( escapeIsland );
							g_Game.SendCarrierToIsland( PlayerAPA, escapeIsland.GetArea() );
							pCarrier.DefenseDronesDock();
							pCarrier.SetInvincibility( false );
							pCarrier.SetCaptive( false );
						}
					}
				}
				EvaluatingCarrierAttack = 1;	//restore lock
			}
			
			if ( pCarrier.GetHealth() > 0.04 && pCarrier.GetHealth() < 0.1 )
				EnemyCarrierPos = pCarrier.GetPosition();
		}
	}

	// User switching to map
	void OnSwitchToMap()
	{
	}

	//! Called when action begins upon particular building
	void OnAction4Building( Building pBuilding )
	{
		GenericAction4Building( pBuilding );
	}

	//! On Game event that should be also handled by script
	void OnGameEvent( string sPlayerEvent )
	{
		switch( sPlayerEvent ) 
		{
			case "carrierenemydetected":
			if ( g_Game.InCutscene() || diecstatus == OBJECTIVE_COMPLETE || di_enemy_exclusion_zone && dienemyislands && !diiua && VectorLength ( diecarrpos - dianchorpoint[dicurrentisland2] ) > 10000 ) break;
				g_Game.PlayGameSound( "scenes/alarm_comp" );
				if( g_Game.IsTimeWarp() )
				{
					g_Game.AddMessage( "#game_canttimewarpenemycarriernear_01", COLOR_YELLOW, LMF_EMPIRE );
					dlg_gen_timewarp_canceled_okoro.ToQueue();
					if( !hint_gen_timewarp_canceled.IsFinished() )
						hint_gen_timewarp_canceled.ToQueue();
				}
				else
					dlg_unt_enemycarrierinrange_okoro_01.ToQueue();
				break;
		}
		GenericGameEvent( sPlayerEvent );
	}
	
	//-----------------------------------------------------------------------------
	/*!
	When strategy map distribution is about to be created	
	*/
	//-----------------------------------------------------------------------------
	void OnStrategyMapCreate()
	{
		int seed = randomize(-1);

		string s = "[CC:Classic] >>> !!! Generating random map (";
		s += itoa(seed);
		s += ")... !!!>";

		Print(s)
		CampaignLog( s, 5);

		IslandsGenerator generator = new IslandsGenerator;
			
		#ifdef DEVELOPER
			DEBUG_ISLAND_GENERATOR			= false;
			DEBUG_ISLAND_GENERATOR_LINK	= false;
			DEBUG_ISLAND_GENERATOR_FINAL	= false;
		#endif

		//uncomment this to debug specific version and paste behind debugtest the variant from log file
		//int debugtest
		//generator.DebugVariant(debugtest);

		//all islands - use generator.SetIslandTable(islands, -1);
		IslandTable = new IslandTableRemap;

/*
		//choosen islands
		const int NUM_ISLANDS = 9;
		string islands[NUM_ISLANDS] = {"Vattland", "Lingard", "Outpost", "Genetix", "Evergreen", "Beacon", "Acheron", "Styx", "Terminus"};
		float currislands = NUM_ISLANDS; 

		IslandTable.SetTable(islands, NUM_ISLANDS);
*/

		//all islands
		float currislands = g_Game.GetNumEnabledIslands();
		IslandTable.SetTable(NULL, -1);

		int bestevaluation = 0;

		//zoom multiplier according the number of islands, must be less or equal to 1
		float maxislands = g_Game.GetNumIslands();
		float zoommul = 0.8*currislands/maxislands;
		zoommul += 0.2;

		int maxnum = 100;
		#ifdef CONSOLE
			maxnum = 20;
		#endif

		for (int i = 0; i < maxnum; i++)
		{
			//generate one variant, compute the evaluation and set the islands position, if the evaluation is better than previous best
			bestevaluation = generator.GetMapVariant(bestevaluation, zoommul);
		}

		IslandTable.CommitIslands();
		delete IslandTable;

		delete generator;

		Print ("Random map generated");
	}

	//! New game started
	void OnNewGame()
	{
	}
	//@}

};
/**@}*/