//-----------------------------------------------------------------------------
// File: GM_BeforeIslandLoad.h
//
// Desc: Init spawing layers
//
// Copyright (c) 2000-2008 Black Element Software. All rights reserved
//-----------------------------------------------------------------------------

void GaeaMission_Campaign::OnBeforeWorldLoad( IslandModel pIsland )
{
	GameProduction prodAPA = PlayerAPA.GetProduction();

	if ( pIsland == NULL )
		return;

	string IslandName = pIsland.GetName();
	string temp = IslandName + "_Classic";
	int sLayer;
	if ( didrone )
		{
		diPlayerUEC.GetCarrierStorage().RemoveItem( DroneScanner, diPlayerUEC.GetCarrierStorage().GetItemCount( ts ) );
		diPlayerUEC.GetCarrierStorage().RemoveItem( ts, diPlayerUEC.GetCarrierStorage().GetItemCount( ts ) );
		}


//	if ( q_Chapter2.GetStatus() == OBJECTIVE_COMPLETE )
//	{
		MultiForce = GetIslandForceMod( pIsland );
		TechLvl = GetIslandTechLevel( pIsland );
		UnitSkill = GetIslandUnitSkill( pIsland );
		UnitSkillRange = GetIslandUnitSkillRange( pIsland );
//	}

	dlg_CTSV_Firewalls_EndFail.ClearFinishedFlag();
	dlg_CTSV_Firewalls_Found.ClearFinishedFlag();

	if ( CheatStart && IslandName == "Fulcrum")
	{
		ForceObjectiveComplete( qCII_HMHDPlatformLoc );
		ForceObjectiveComplete( qCII_HMHDMissileLoc );
	}

	if ( pIsland.GetPlayer() == PlayerNeutral )
		MultiForce = 0;

	//-----------------------------------------------------------------------------------
	if ( pIsland.GetPlayer() == PlayerUEC )
	{
		if ( IslandName == "Taksaven" )
		{
			if ( RC_IsActive( "Taksaven" ) )
			{
				g_Game.SetSpawnLayer( Taksaven_FPSMission );
				return;
			}
		}

		if ( IslandName == "Vattland" )
		{
			if ( RC_IsActive( "Vattland" ) && CII_HMHDMissileLoc == "Vattland" )
			{
				g_Game.SetSpawnLayer( Vattland_FPSMission );
				return;
			}
		}

		if ( IslandName == "Lingard" )
		{
			if ( RC_IsActive( "Lingard" ) && CII_HMHDMissileLoc == "Lingard" )
			{
				g_Game.SetSpawnLayer( Lingard_FPSMission );
				return;
			}
		}

		if ( IslandName == "Isolus" )
		{
			if ( RC_IsActive( "Isolus" ) && CII_HMHDMissileLoc == "Isolus" )
			{
				g_Game.SetSpawnLayer( Isolus_FPSMission );
				return;
			}
		}

		if ( IslandName == "Duessa" )
		{
			if ( CIII_AuroraFound && !IsObjectiveCompleted( qCIII_FindAurora ) )
			{
				g_Game.SetSpawnLayer( Duessa_FPSMission );
				return;
			}
		}

		if ( IslandName == "Terminus" )
		{
			if ( CIII_AuroraFound && !IsObjectiveCompleted( qCIII_FindAurora ) )
			{
				g_Game.SetSpawnLayer( Terminus_FPSMission );
				return;
			}
		}

		if ( IslandName == "Medusa" )
		{
			if ( CIII_AuroraFound && !IsObjectiveCompleted( qCIII_FindAurora ) )
			{
				g_Game.SetSpawnLayer( Medusa_FPSMission );
				return;
			}
		}

		if ( IslandName == "Sanctuary" )
		{
			if ( CIII_AuroraFound && !IsObjectiveCompleted( qCIII_FindAurora ) )
			{
				g_Game.SetSpawnLayer( Sanctuary_FPSMission );
				return;
			}
		}

		if ( IslandName == "Somnus" )
		{
			if ( CIII_AuroraFound && !IsObjectiveCompleted( qCIII_FindAurora ) )
			{
				g_Game.SetSpawnLayer( Somnus_FPSMission );
				return;
			}
		}

		if ( IslandName == "Milestone" )
		{
			if ( CIII_AuroraFound && !IsObjectiveCompleted( qCIII_FindAurora ) )
			{
				g_Game.SetSpawnLayer( Milestone_FPSMission );
				return;
			}
		}

		if ( IslandName == "Genetix" )
		{
			if ( CIII_AuroraFound && !IsObjectiveCompleted( qCIII_FindAurora ) )
			{
				g_Game.SetSpawnLayer( Genetix_FPSMission );
				return;
			}
		}

		if ( IslandName == "Fornax" )
		{
			if ( qCIII_ShieldFornax.GetStatus() == OBJECTIVE_PENDING )
				g_Game.SetSpawnLayer( Fornax_FirstMission );
	
			return;
		}

		if ( IslandName == "Magma" )
		{
			if ( qCIII_ShieldMagma.GetStatus() == OBJECTIVE_PENDING )
				g_Game.SetSpawnLayer( Magma_FirstMission );
	
			return;
		}

		if ( IslandName == "Obsidian" )
		{
			if ( qCIII_ShieldObsidian.GetStatus() == OBJECTIVE_PENDING )
				g_Game.SetSpawnLayer( Obsidian_FirstMission );
	
			return;
		}

		if ( IslandName == "Avernus" )
		{
			if ( qCIII_ShieldAvernus.GetStatus() == OBJECTIVE_PENDING )
				g_Game.SetSpawnLayer( Avernus_FirstMission );
	
			return;
		}

		if ( PlayerAPA.GetCurrentIsland() != pIsland )
			g_Game.SetSpawnLayer( NoUnits );
		else
		{
			if ( GetValue(NULL, temp , 0, sLayer) )

			g_Game.SetSpawnLayer( sLayer );
		}
		return;
	}

//-----------------------------------------------------------------------------------
//----------------------------TUTEN RIAL ISLANDS-------------------------------
//-----------------------------------------------------------------------------------

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Vulcan" )
	{
		if ( !IsObjectiveCompleted( q_Vulcan_GetCarrier ) )
			g_Game.SetSpawnLayer( Vulcan_FirstMission );
		else
		{
			if ( !IsObjectiveCompleted( q_Outpost )  )
				g_Game.SetSpawnLayer( Vulcan_NoUnits );
			else
				g_Game.SetSpawnLayer( Vulcan_Classic );
		}
	}

	//-----------------------------------------------------------------------------------	
	if ( IslandName == "Arachnid" )
	{
		if ( !IsObjectiveCompleted( q_Arachnid ) )
		{
			g_ActionQueue.RemoveAction( dlg_Iis_adv_Info_Essi_01 );
			g_ActionQueue.RemoveAction( dlg_Iis_adv_Info_Essi_02 );
			g_ActionQueue.RemoveAction( dlg_Iis_adv_Info_Essi_03 );
			g_ActionQueue.RemoveAction( dlg_Iis_adv_Info_Essi_04 );
			g_ActionQueue.RemoveAction( dlg_Iis_adv_Info_Essi_05 );
			g_ActionQueue.RemoveAction( dlg_Iis_adv_Info_Essi_06 );
						
			g_Game.SetSpawnLayer( Arachnid_FirstMission );
		}
		else
			g_Game.SetSpawnLayer( Arachnid_Classic );
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Treasure" )
	{
		if ( !IsObjectiveCompleted( q_Treasure ) )
			g_Game.SetSpawnLayer( Treasure_FirstMission );
		else
			g_Game.SetSpawnLayer( Treasure_Classic );
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Frontier" )
	{
		if ( !IsObjectiveCompleted( q_Frontier ) )
			g_Game.SetSpawnLayer( Frontier_FirstMission );
		else
			g_Game.SetSpawnLayer( Frontier_Classic );
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Outpost" )
	{
		if ( !IsObjectiveCompleted( q_Outpost ) )
			g_Game.SetSpawnLayer( Outpost_FirstMission );
		else
			g_Game.SetSpawnLayer( Outpost_Classic );
	}



//-----------------------------------------------------------------------------------
//-----------------------SECOND CHAPTER ISLANDS----------------------------------
//-----------------------------------------------------------------------------------

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Nemesis" )
	{
		g_Game.SetSpawnLayer( Nemesis_Classic );
		if ( pIsland.GetPlayer() == PlayerAPA )
		{
			pIsland.UniPostRestore();
			if ( !IsObjectiveCompleted( qCII_Nemesis1st ) )
				g_Game.SetSpawnLayer( Nemesis_FirstMission );
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Evergreen" )
	{
		g_Game.SetSpawnLayer( Evergreen_Classic );
		if ( pIsland.GetPlayer() == PlayerAPA )
		{
			pIsland.UniPostRestore();
			if ( !IsObjectiveCompleted( qCII_Evergreen1st ) )
				g_Game.SetSpawnLayer( Evergreen_FirstMission );
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Beacon" )
	{
		g_Game.SetSpawnLayer( Beacon_Classic );
		if ( pIsland.GetPlayer() == PlayerAPA )
		{
			pIsland.UniPostRestore();
			if ( !IsObjectiveCompleted( qCII_Beacon1st ) )
				g_Game.SetSpawnLayer( Beacon_FirstMission );
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Bacchus" )
	{
		if ( !IsObjectiveCompleted( qCII_Bacchus1st ) && !IsObjectiveCompleted( q_Chapter2 ) )
			g_Game.SetSpawnLayer( Bacchus_FirstMission );
		else
			g_Game.SetSpawnLayer( Bacchus_Classic );
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Endymion" )
	{
		g_Game.SetSpawnLayer( Endymion_Classic );
		if ( pIsland.GetPlayer() == PlayerAPA )
		{
			pIsland.UniPostRestore();
			if ( !IsObjectiveCompleted( qCII_Endymion1st ) && !diiru )
				g_Game.SetSpawnLayer( Endymion_FirstMission );
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Granite" )
	{
		g_Game.SetSpawnLayer( Granite_Classic );
		if ( pIsland.GetPlayer() == PlayerAPA )
		{
			pIsland.UniPostRestore();
			if ( !IsObjectiveCompleted( qCII_Granite1st ) && !diiru )
				g_Game.SetSpawnLayer( Granite_FirstMission );
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Taksaven" )
	{
		if ( !IsObjectiveCompleted( qCII_Taksaven1st ) )
			g_Game.SetSpawnLayer( Taksaven_FirstMission );
		else
		{
			if ( pIsland.GetPlayer() == PlayerAPA )
				pIsland.UniPostRestore();

			g_Game.SetSpawnLayer( Taksaven_Classic );
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Vattland" )
	{
		g_Game.SetSpawnLayer( Vattland_Classic );
		if ( pIsland.GetPlayer() == PlayerAPA )
		{
			if ( !IsObjectiveCompleted( qCII_Vattland1st ) )
				g_Game.SetSpawnLayer( Vattland_FirstMission );
			else
				pIsland.UniPostRestore();
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Lingard" )
	{
		pIsland.UniPostRestore();
		g_Game.SetSpawnLayer( Lingard_Classic );
	}
	
	//-----------------------------------------------------------------------------------
	if ( IslandName == "Isolus" )
	{
		if ( !IsObjectiveCompleted( qCII_Isolus1st ) )
			g_Game.SetSpawnLayer( Isolus_Classic );
		else
		{
			if ( RC_IsActive( "Isolus" ) && CII_HMHDMissileLoc == "Isolus" )
				g_Game.SetSpawnLayer( Isolus_FPSMission );
			else
				g_Game.SetSpawnLayer( Isolus_Classic );
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Fulcrum" )
	{
		if ( !CheatStart )
		{
			if ( !IsObjectiveCompleted( q_Chapter2 ) )
			{
				if ( !IsObjectiveCompleted( qCII_HMHD ) )
				{
					g_Game.SetSpawnLayer( Fulcrum_PreMission );
					dlg_CTSV_warningaftersail_fulcrum.ToQueue();
				}
				else
					g_Game.SetSpawnLayer( Fulcrum_FirstMission );
			}
			else
				g_Game.SetSpawnLayer( Fulcrum_Classic );
		}
		else
			g_Game.SetSpawnLayer( Fulcrum_FirstMission );
	}

//-----------------------------------------------------------------------------------
//------------------------THIRD CHAPTER ISLANDS-----------------------------------
//-----------------------------------------------------------------------------------

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Duessa" )
		g_Game.SetSpawnLayer( Duessa_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Terminus" )
		g_Game.SetSpawnLayer( Terminus_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Medusa" )
		g_Game.SetSpawnLayer( Medusa_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Sanctuary" )
		g_Game.SetSpawnLayer( Sanctuary_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Somnus" )
		g_Game.SetSpawnLayer( Somnus_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Acheron" )
		g_Game.SetSpawnLayer( Acheron_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Naiades" )
		g_Game.SetSpawnLayer( Naiades_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Styx" )
		g_Game.SetSpawnLayer( Styx_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Hades" )
		g_Game.SetSpawnLayer( Hades_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Milestone" )
		g_Game.SetSpawnLayer( Milestone_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Genetix" )
		g_Game.SetSpawnLayer( Genetix_Classic );

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Avernus" )
	{
		if ( qCIII_ShieldAvernus.GetStatus() == OBJECTIVE_UNAVAILABLE )
		{
			if ( CIII_ShieldLoc1 == "Avernus" || CIII_ShieldLoc2 == "Avernus" )
				qCIII_ShieldAvernus.SetStatus( OBJECTIVE_PENDING );
		}

		if ( qCIII_ShieldAvernus.GetStatus() == OBJECTIVE_PENDING )
			g_Game.SetSpawnLayer( Avernus_FirstMission );
		else
			g_Game.SetSpawnLayer( Avernus_Classic );
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Magma" )
	{
		if ( qCIII_ShieldMagma.GetStatus() == OBJECTIVE_UNAVAILABLE )
		{
			if ( CIII_ShieldLoc1 == "Magma" || CIII_ShieldLoc2 == "Magma" )
				qCIII_ShieldMagma.SetStatus( OBJECTIVE_PENDING );
		}

		if ( qCIII_ShieldMagma.GetStatus() == OBJECTIVE_PENDING )
			g_Game.SetSpawnLayer( Magma_FirstMission );
		else
			g_Game.SetSpawnLayer( Magma_Classic );
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Obsidian" )
	{
		if ( qCIII_ShieldObsidian.GetStatus() == OBJECTIVE_UNAVAILABLE )
		{
			if ( CIII_ShieldLoc1 == "Obsidian" || CIII_ShieldLoc2 == "Obsidian" )
				qCIII_ShieldObsidian.SetStatus( OBJECTIVE_PENDING );
		}

		if ( qCIII_ShieldObsidian.GetStatus() == OBJECTIVE_PENDING )
			g_Game.SetSpawnLayer( Obsidian_FirstMission );
		else
			g_Game.SetSpawnLayer( Obsidian_Classic );
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Fornax" )
	{
		if ( qCIII_ShieldFornax.GetStatus() == OBJECTIVE_UNAVAILABLE )
		{
			if ( CIII_ShieldLoc1 == "Fornax" || CIII_ShieldLoc2 == "Fornax" )
				qCIII_ShieldFornax.SetStatus( OBJECTIVE_PENDING );
		}

		if ( qCIII_ShieldFornax.GetStatus() == OBJECTIVE_PENDING )
			g_Game.SetSpawnLayer( Fornax_FirstMission );
		else
			g_Game.SetSpawnLayer( Fornax_Classic );
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "Thermopylae" )
	{
		if ( !pIsland.IsEnabledOnMap() )
			g_Game.SetSpawnLayer( Thermopylae_Classic );
		else
		{
			if ( qCIII_ShieldThermopylae.GetStatus() != OBJECTIVE_COMPLETE )
				g_Game.SetSpawnLayer( Thermopylae_PreMission );
			else
				g_Game.SetSpawnLayer( Thermopylae_FirstMission );				
		}
	}

	//-----------------------------------------------------------------------------------
	if ( IslandName == "DeadLock" )
	{
		if ( IsObjectiveCompleted( qCIII_ThermopylaeConq1st ) )
			g_Game.SetSpawnLayer( DeadLock_FirstMission );
		else
			g_Game.SetSpawnLayer( DeadLock_Classic );
	}

	//-----------------------------------------------------------------------------------
	//------------------------------General Settings-------------------------------------
	//-----------------------------------------------------------------------------------


	//-----------------------------------------------------------------------------------
	//always restore unipost mission when island is controlled by APA
	//and spawning classic layer
	if ( pIsland.GetPlayer() == PlayerAPA )
	{
		temp = IslandName + "_Classic"
		sLayer;

		if ( GetValue(NULL, temp , 0, sLayer) )
		{
			if ( g_Game.GetSpawnLayer() == sLayer )
				pIsland.UniPostRestore();
		}
	}
}

void GaeaMission_Campaign::OnProcessWorldLoad( IslandModel pIsland )
{
	if ( pIsland == NULL )
		return;

	if ( SPAWN_CURRENT_LAYER )
	{
		g_Game.SetSpawnLayer( CURRENT_LAYER );
		return;
	}
}
